global REP_JEUX
global PARAM
source [file join $REP_JEUX "Jeux_Grille.tcl"]

global couleurs
global polices
global PARAM
global casinoCouleursSalle
set idSalle Des

  set couleurs(PoliceTitreJeu) $casinoCouleursSalle($idSalle,police)
  set couleurs(FondFenetreJeu) $casinoCouleursSalle($idSalle,fond)
set couleurs(PoliceScoresJeu) "#ffffff"
set couleurs(FondOutilSelectionne) $couleurs(PoliceTitreJeu)
set couleurs(FondOutilNonSelectionne) $couleurs(FondFenetreJeu) ;#"#FFFFFF"
set polices(TitreJeu) [font create -family Courier -size [expr {$PARAM(taillePoliceBase) + 4}] -weight bold -underline true]
set polices(ScoresJeu) [font create -family Courier -size $PARAM(taillePoliceBase) -slant italic]


global nbOutils
set nbOutils 2

for {set i 1} {$i <= $nbOutils} {incr i} {
  ajouterOutil "de"
}

global nbCoupsMax
set nbCoupsMax 1

global nbTours
set nbTours 1

global imagesFaces
global listeOutilsHasard
foreach face $listeOutilsHasard(1,faces) {
#  set imagesFaces($face) [image create photo "img$face" -format png -file [file join "Img" "DeRouge_$face.png"]]
  set imagesFaces($face) [getImageFichier [file join "Img" "DeRouge_$face.png"]]
}

global titreJeu
set titreJeu "Evitez le 7..."

global nomActionTirage
set nomActionTirage "Lancer les ds"

global montantPerd
set montantPerd 1

global labelExplMises
set labelExplMises "$nbCoupsMax lancers par tour max."
if {$nbCoupsMax == 1} {
  set labelExplMises "1 seul lancer par tour."
}
append labelExplMises "\n$montantPerd $PARAM(unite) la mise.\nRemporte la somme indique."

global cocheGrilleAuto
set cocheGrilleAuto true

global grille
creerGrilleFichier [file join $REP_JEUX "Jeu_Evite7_Grille.txt"]

proc cocheGrilleAuto {} {
  global grille
set i 1
set continuer true
set trouve false
  while {$continuer} {
    if {$grille($i,action) != ""} {
      set grille($i,score) [eval "$grille($i,action)"]
      if {$grille($i,score) != 0} {
        set trouve true
        set continuer false
      }
    }
    if {$continuer} {
      incr i
      if {$i > $grille(taille)} {
        set continuer false
      }
    }
  }
  if $trouve {
    choisirCaseGrille $i 1000
  } else {
    choisirCaseGrille -1
  }
#  pause 2000
#  commencerJeu
}

proc animer {} {
set nbAnim [expr {int(rand() * 4) + 6}]
  animerAuHasard 50 $nbAnim
}

proc sommeVaut {attendue} {
  global outils
  global nbOutils

  set sommeObtenue 0
 for {set i 1} {$i <= $nbOutils} {incr i} {
      incr sommeObtenue $outils($i,valeur)
 }
  if {$sommeObtenue == $attendue} {
return true
  } else {
return false
  }
}

proc lblAideJeu {} {
  global nbCoupsMax
  global montantPerd
  global PARAM

  msgBox \
"But du jeu : Obtenir la combinaison des deux ds de sorte que la somme des faces\
rapporte le plus de points, en vitant le 7 qui vous fera perdre de l'argent...

Principe : Lancez les ds et voyez ce que vous obtenez.

Rapports : jouez $montantPerd $PARAM(unite) ; \
remportez le gain correspondant !" "Aide"
}
