global REP_JEUX
global PARAM
source [file join $REP_JEUX "Jeux_Pari_1_1_Custom.tcl"]

  global couleurs
  global polices
global casinoCouleursSalle
set idSalle Loterie

set couleurs(PoliceTitreJeu) $casinoCouleursSalle($idSalle,police)
set couleurs(FondFenetreJeu) $casinoCouleursSalle($idSalle,fond)
  set couleurs(PoliceScoresJeu) "#ffffff"
  set couleurs(PoliceResultatTirage) "#ffffff"
  set couleurs(FondSelectionne) "#ffff00"
  set couleurs(FondNonSelectionne) "#FFFFFF"
set couleurs(FondTapisRoulette) "#007300"
set polices(Roulette) [font create -family Courier -size [expr {$PARAM(taillePoliceBase) - 1}] -slant italic -weight bold]

global titreJeu
set titreJeu "Roulette"

global nomActionTirage
set nomActionTirage "Lancer !"

global nbFacesMiseesMax
set nbFacesMiseesMax -1

global montantGagne
global montantPerd
set montantGagne 20
set montantPerd 1

global montantGagneCustom
set montantGagneCustom 2

#global delaiAvantEfface
#set delaiAvantEfface 2000

ajouterOutil "roulette36"

global listeOutilsHasard

global listeFacesPossibles
set listeFacesPossibles [lsort $listeOutilsHasard(1,faces)]
lappend listeFacesPossibles PairV ImpairV RougeR NoirN "1-18V" "19-36V"


# Retourne toujours -1, mais effectue correctement les calculs :
proc correspond {facesMisees faceTiree} {
  global listeOutilsHasard
  global montantGagne
  global montantGagneCustom
  global montantPerd
  global listeFacesPossibles
  global couleurs

  set val [valeurFace $faceTiree]
  incrementerStats $faceTiree false
  set val [string trimleft $val "0"]
  if {$val == ""} {
    set val 0
  }
  set val [expr {0 + int($val)}]
  set coul [couleurFace $faceTiree]
  set totalGains 0
set facesGagnantes [list]
  foreach faceMisee $facesMisees {
    switch $faceMisee {
      "PairV" {
        if {$val != 0 && [expr {$val % 2}] == 0} {
lappend facesGagnantes [lsearch $listeFacesPossibles $faceMisee]
lappend facesGagnantes $faceMisee
          gagner $montantGagneCustom 1
          incr totalGains $montantGagneCustom
        }
      }
      "ImpairV" {
        if {$val != 0 && [expr {$val % 2}] != 0} {
lappend facesGagnantes [lsearch $listeFacesPossibles $faceMisee]
lappend facesGagnantes $faceMisee
          gagner $montantGagneCustom 1
          incr totalGains $montantGagneCustom
        }
      }
      "RougeR" {
        if {$coul == [couleurFace "R"]} {
lappend facesGagnantes [lsearch $listeFacesPossibles $faceMisee]
lappend facesGagnantes $faceMisee
          gagner $montantGagneCustom 1
          incr totalGains $montantGagneCustom
        }
      }
      "NoirN" {
        if {$coul == [couleurFace "N"]} {
lappend facesGagnantes [lsearch $listeFacesPossibles $faceMisee]
lappend facesGagnantes $faceMisee
          gagner $montantGagneCustom 1
          incr totalGains $montantGagneCustom
        }
      }
      "1-18V" {
        if {$val >= 1 && $val <= 18} {
lappend facesGagnantes [lsearch $listeFacesPossibles $faceMisee]
lappend facesGagnantes $faceMisee
          gagner $montantGagneCustom 1
          incr totalGains $montantGagneCustom
        }
      }
      "19-36V" {
        if {$val >= 19 && $val <= 36} {
lappend facesGagnantes [lsearch $listeFacesPossibles $faceMisee]
lappend facesGagnantes $faceMisee
          gagner $montantGagneCustom 1
          incr totalGains $montantGagneCustom
        }
      }
      default {
        if {$faceMisee == $faceTiree} {
lappend facesGagnantes [lsearch $listeFacesPossibles $faceMisee]
lappend facesGagnantes $faceMisee
          gagner $montantGagne 1
          incr totalGains $montantGagne
        }
      }
    }
  }
  majNomsEtScores .frmJeu.lblGains
incrementerStats "total gains" true $totalGains

for {set i 0} {$i < 3} {incr i} {
pause 500
foreach {indFace face} $facesGagnantes {
     .frmJeu.frmChoix.cmd$indFace configure -foreground $couleurs(PoliceResultatTirage) -background "[couleurFace $face]"
}
pause 500
foreach {indFace face} $facesGagnantes {
     .frmJeu.frmChoix.cmd$indFace configure -foreground [couleurFace $face] -background $couleurs(FondSelectionne)
}
update
}
  return -1
}


proc couleurFace {face} {
  set coul [string index $face end]
  switch $coul {
    R {return "#ff0000"}
    V {return "#006200"}
    N {return "#000000"}
  }
}

proc valeurFace {face} {
  return [string range $face 0 end-1]
}


global affichageOk
set affichageOk false

proc majAfficheJeu {{majMises true}} {
  global facesMisees
  global faceTiree
  global imagesFaces
  global couleurs
  global polices
  global listeOutilsHasard
global listeFacesPossibles
global affichageOk
  global montantGagne
  global montantGagneCustom
  global montantPerd
  global PARAM

  if {! $affichageOk} {
    set ligne 1
    set colonne 1
    set nbColonnes [expr {int([llength $listeOutilsHasard(1,faces)] / 4) + 1}]
    set i 0
.frmJeu.frmChoix configure -background $couleurs(FondTapisRoulette)
label .frmJeu.frmChoix.lblVideHaut -text "" -font $polices(Normale) -background $couleurs(FondTapisRoulette) 
grid .frmJeu.frmChoix.lblVideHaut -row $ligne -column 1
incr ligne
    foreach face $listeFacesPossibles {
      destroy .frmJeu.frmChoix.cmd$i
      button .frmJeu.frmChoix.cmd$i -text "[valeurFace $face]" \
        -background "[couleurFace $face]" -foreground $couleurs(PoliceResultatTirage) \
        -command "choisir $i" -font $polices(Roulette) -width 3
      if {$i == 0} {
        grid .frmJeu.frmChoix.cmd$i -column $colonne -row $ligne -padx 1 -rowspan 1
      } else {
        if {$i >= [llength $listeOutilsHasard(1,faces)]} {
          .frmJeu.frmChoix.cmd$i configure -width 6
          grid .frmJeu.frmChoix.cmd$i -column $colonne -row $ligne -padx 1 -columnspan 2
          incr colonne
        } else {
          grid .frmJeu.frmChoix.cmd$i -column $colonne -row $ligne -padx 1
        }
      }
      incr i
      incr colonne
      if {$colonne > $nbColonnes || $i == [llength $listeOutilsHasard(1,faces)]} {
        set colonne 2
        if {$i >= [llength $listeOutilsHasard(1,faces)]} {
          set colonne 0
        }
        incr ligne
      }
    }
label .frmJeu.frmChoix.lblVideBas -text "" -font $polices(Normale) -background $couleurs(FondTapisRoulette) 
grid .frmJeu.frmChoix.lblVideBas -row [incr ligne] -column 1

    .frmJeu.lblMises configure -text "$montantPerd $PARAM(unite) par mise :
gagne $montantGagneCustom $PARAM(unite) par case spciale
+ $montantGagne $PARAM(unite) si bon numro."

    set affichageOk true
  }

  if {$majMises} {
    set i 0
    foreach face $listeFacesPossibles {
set indMisee [lsearch $facesMisees $face]
if {$indMisee < 0} {
      .frmJeu.frmChoix.cmd$i configure -foreground $couleurs(PoliceResultatTirage) -background "[couleurFace $face]"
} else {
      .frmJeu.frmChoix.cmd$i configure -foreground [couleurFace $face] -background $couleurs(FondSelectionne)
}
      incr i
    }

#    foreach face $facesMisees {
#      set indFaceMisee [lsearch $listeFacesPossibles "$face"]
#      .frmJeu.frmChoix.cmd$indFaceMisee configure -foreground [couleurFace $face] -background $couleurs(FondSelectionne)
#    }
  }
  set imageFace ""
  catch {set imageFace $imagesFaces($faceTiree)}
  if {$imageFace != ""} {
    .frmJeu.lblTirage configure -image $imageFace -text "[lblAvantRes][lblApresRes]"
  } else {
    set couleur [couleurFace $faceTiree]
    if {$couleur == ""} {
      set couleur $couleurs(FondFenetreJeu)
    }
    .frmJeu.lblTirage configure -text "[lblAvantRes][valeurFace $faceTiree][lblApresRes]" \
        -background "$couleur" -foreground $couleurs(PoliceResultatTirage) \
        -width 3
  }
  update
}

proc animer {} {
  set nbAnim [expr {int(rand() * 6) + 10}]
  animerALaSuite 120 $nbAnim
}

proc lblAideJeu {} {
  global nbFacesMiseesMax
  global montantPerd
  global montantGagne
  global montantGagneCustom
  global PARAM

  set msg "But du jeu : Deviner le bon numro.

Principe : Tenter de deviner le numro gagnant, sa couleur, sa parit, et/ou la fourchette dans laquelle il figure pour remporter le plus d'argent.

Rapports : jouez $montantPerd $PARAM(unite) par mise ;\
remportez $montantGagneCustom $PARAM(unite) par case spciale\
+ $montantGagne $PARAM(unite) si vous avez trouv le bon numro !"

msgBox "$msg" "Aide"
}
