global REP_JEUX
global PARAM
source [file join $REP_JEUX "Jeux_Tir.tcl"]

global couleurs
global polices
global casinoCouleursSalle
set idSalle Tirs

set couleurs(PoliceTitreJeu) $casinoCouleursSalle($idSalle,police)
set couleurs(FondFenetreJeu) $casinoCouleursSalle($idSalle,fond)
set couleurs(PoliceScoresJeu) $casinoCouleursSalle($idSalle,police)
set couleurs(PolicePlombs) $casinoCouleursSalle($idSalle,police)
set couleurs(FondZoneTir) "#000000"
#set polices(TitreJeu) [font create -family Courier -size [expr {$PARAM(taillePoliceBase) + 6}] -weight bold -underline true]
#set polices(Plombs) [font create -family Courier -size [expr {$PARAM(taillePoliceBase) - 2}]]
#set polices(ScoresJeu) $polices(Plombs)


global titreJeu
set titreJeu "Tir aux ballons"

global listePlombsAchetablesNbEtPrix
set listePlombsAchetablesNbEtPrix [list 4 5 9 10 15 15]

global montantGagne
set montantGagne 3

global doitFinirPourGagner
set doitFinirPourGagner true

global lblExplique
set lblExplique "Explosez les 3 ballons\npour gagner $montantGagne $PARAM(unite) !"

global VIT_X_MIN
global VIT_X_MAX
global VIT_Y_MIN
global VIT_Y_MAX
set VIT_X_MIN -4
set VIT_X_MAX 4
set VIT_Y_MIN -4
set VIT_Y_MAX 4

global DELAI_ANIM
set DELAI_ANIM 15 ;#20 ;#15

global tremblementMax
set tremblementMax 3


proc initObjets {} {
  global TAILLE
  global nbObjets
  
  set nbObjets 0
  foreach ballon {Bleu Jaune Rouge} {
#    ajouterObjet [expr int($TAILLE*rand())] [expr int($TAILLE*rand())] true [image create photo -format png -file [file join "Img" "Ballon$ballon.png"]] [image create photo -format png -file [file join "Img" "vide.png"]]
    ajouterObjet [expr {int($TAILLE*rand())}] [expr {int($TAILLE*rand())}] true [getImageFichier [file join "Img" "Ballon$ballon.png"]] [getImageFichier [file join "Img" "vide.png"]]
  }
}

proc modifVitessesMinMax_cp {indObjet} {
  global objets
  
  set probChange [expr {int(30*rand())}]
  if {$probChange == 1} {
    set objets($indObjet,vitXmin) [expr {$objets($indObjet,vitXmin) - 1}] 
    set objets($indObjet,vitXmax) [expr {$objets($indObjet,vitXmax) - 1}] 
  }
  if {$probChange == 2} {
    set objets($indObjet,vitXmin) [expr {$objets($indObjet,vitXmin) + 1}] 
    set objets($indObjet,vitXmax) [expr {$objets($indObjet,vitXmax) + 1}] 
  }
  if {$probChange == 3} {
    set objets($indObjet,vitYmin) [expr {$objets($indObjet,vitYmin) - 1}]
    set objets($indObjet,vitYmax) [expr {$objets($indObjet,vitYmax) - 1}] 
  }
  if {$probChange == 4} {
    set objets($indObjet,vitYmin) [expr {$objets($indObjet,vitYmin) + 1}] 
    set objets($indObjet,vitYmax) [expr {$objets($indObjet,vitYmax) + 1}] 
  }

}

proc modifVitessesMinMax {indObjet} {
  global objets
global VIT_X_MIN
global VIT_X_MAX
global VIT_Y_MIN
global VIT_Y_MAX

  set probChange [expr {int(150*rand())}]
  if {$probChange < 5} {
    set objets($indObjet,vitXmin) $VIT_X_MIN
    set objets($indObjet,vitXmax) $VIT_X_MAX
    set objets($indObjet,vitYmin) $VIT_Y_MIN
    set objets($indObjet,vitYmax) $VIT_Y_MAX
  }
  if {$objets($indObjet,vitXmin) == $VIT_X_MIN && $objets($indObjet,vitXmax) == $VIT_X_MAX} {
    set sens [expr {int(2 * rand())}]
    if {$sens == 0} {
      set objets($indObjet,vitXmin) 0
      set objets($indObjet,vitXmax) $objets($indObjet,vitXmax)
    } else {
      set objets($indObjet,vitXmin) [expr {0 - $objets($indObjet,vitXmax)}]
      set objets($indObjet,vitXmax) 0
    }
    set sens [expr {int(2 * rand())}]
    if {$sens == 0} {
      set objets($indObjet,vitYmin) 0
      set objets($indObjet,vitYmax) $objets($indObjet,vitYmax)
    } else {
      set objets($indObjet,vitYmin) [expr {0 - $objets($indObjet,vitYmax)}]
      set objets($indObjet,vitYmax) 0
    }
if {$probChange == 1} {
      set objets($indObjet,vitXmin) [expr {int($objets($indObjet,vitXmin) / 2)}]
}
if {$probChange == 2} {
      set objets($indObjet,vitXmax) [expr {int($objets($indObjet,vitXmax) / 2)}]
}
if {$probChange == 3} {
      set objets($indObjet,vitYmin) [expr {int($objets($indObjet,vitYmin) / 2)}]
}
if {$probChange == 4} {
      set objets($indObjet,vitYmax) [expr {int($objets($indObjet,vitYmax) / 2)}]
}
  }

}


