global REP_JEUX
global PARAM
source [file join $REP_JEUX "Jeux_Tir.tcl"]

global couleurs
global polices
global casinoCouleursSalle
set idSalle Tirs

set couleurs(PoliceTitreJeu) $casinoCouleursSalle($idSalle,police)
set couleurs(FondFenetreJeu) $casinoCouleursSalle($idSalle,fond)
set couleurs(PoliceScoresJeu) $casinoCouleursSalle($idSalle,police)
set couleurs(PolicePlombs) $casinoCouleursSalle($idSalle,police)
set couleurs(FondZoneTir) "#000000"
#set polices(TitreJeu) [font create -family Courier -size [expr {$PARAM(taillePoliceBase) + 6}] -weight bold -underline true]
#set polices(Plombs) [font create -family Courier -size [expr {$PARAM(taillePoliceBase) - 2}]]
#set polices(ScoresJeu) $polices(Plombs)


global titreJeu
set titreJeu "Tir aux pipes"

global listePlombsAchetablesNbEtPrix
set listePlombsAchetablesNbEtPrix [list 10 15 30 25 40 30]

global montantGagne
set montantGagne 35

global doitFinirPourGagner
set doitFinirPourGagner true

global NB_PIPES
set NB_PIPES 20

global lblExplique
set lblExplique "Touchez les $NB_PIPES pipes\npour remporter $montantGagne $PARAM(unite) !"

global imagePipe
#set imagePipe [image create photo -format png -file [file join "Img" "PipeBlanche.png"]]
set imagePipe [getImageFichier [file join "Img" "PipeBlanche.png"]]
global imagePipeTiree
#set imagePipeTiree [image create photo -format png -file [file join "Img" "PipeBlancheKO.png"]]
set imagePipeTiree [getImageFichier [file join "Img" "PipeBlancheKO.png"]]

global largImage
set largImage [image width $imagePipe]
global hautImage
set hautImage [image height $imagePipe]

global VIT_X_MIN
global VIT_X_MAX
global VIT_Y_MIN
global VIT_Y_MAX
set VIT_X_MIN 4
set VIT_X_MAX 4
set VIT_Y_MIN 0
set VIT_Y_MAX 0

global DELAI_ANIM
set DELAI_ANIM 50

global tremblementMax
set tremblementMax 4

global BLOQUER_AUX_BORD
set BLOQUER_AUX_BORD false

proc initObjets {} {
  global TAILLE
  global nbObjets
  global NB_PIPES
  global imagePipe
  global largImage
  global hautImage
  global imagePipeTiree
  global objets

  set nbObjets 0
  set milieu [expr {int($NB_PIPES / 2)}]
  set espacement [expr {(2 * $largImage + $TAILLE) / $milieu}]
  set hauteur [expr {int($TAILLE / 2) - $hautImage}]
  for {set i 0} {$i < $milieu} {incr i} {
    ajouterObjet [expr {int($espacement * $i - $largImage)}] $hauteur true $imagePipe $imagePipeTiree
  }
  
  set espacement [expr {(2 * $largImage + $TAILLE) / ($NB_PIPES - $milieu)}]
  set hauteur [expr {int($TAILLE / 2) + $hautImage}]
  for {set i $milieu} {$i < $NB_PIPES} {incr i} {
    ajouterObjet [expr {int($espacement * ($i - $milieu) - $largImage)}] $hauteur true $imagePipe $imagePipeTiree
    set objets($nbObjets,vitXmin) -2
    set objets($nbObjets,vitXmax) -2
  }

}

proc affichageSpecifique {} {
  global TAILLE
  global largImage
  global hautImage

set tailleCanvas [expr {$TAILLE + 2}]
  set hauteur [expr {int($TAILLE / 2) - $hautImage}]
set couleur "#715913"
  .frmJeu.frmZone1.frmZoneTir create rect 0 0 $tailleCanvas [expr {$hauteur - int($hautImage / 2)}] -fill $couleur -width 0 -tag decor
#  .frmJeu.frmZone1.frmZoneTir create rect 0 [expr {$hauteur - int($hautImage / 2)}] [expr {2 * $largImage}] [expr {$hauteur + $hautImage}] -fill $couleur -width 0 -tag decor
#  .frmJeu.frmZone1.frmZoneTir create rect [expr {$tailleCanvas - 2 * $largImage}] [expr {$hauteur - int($hautImage / 2)}] $tailleCanvas [expr {$hauteur + $hautImage}] -fill $couleur -width 0 -tag decor
 set hauteur2 [expr {int($TAILLE / 2) + $hautImage}]
  .frmJeu.frmZone1.frmZoneTir create rect 0 [expr {$hauteur + $hautImage}] $tailleCanvas [expr {$hauteur2 - int($hautImage / 2)}] -fill $couleur -width 0 -tag decor
  .frmJeu.frmZone1.frmZoneTir create rect 0 [expr {$hauteur2 + $hautImage}] $tailleCanvas $tailleCanvas -fill $couleur -width 0 -tag decor

.frmJeu.frmZone1.frmZoneTir raise viseur
}


proc modifVitessesMinMax {indObjet} {
  global objets
  global TAILLE
  global largImage

  if {$objets($indObjet,posX) > $TAILLE} {
    set objets($indObjet,posX) [expr {0 - $largImage}]
  } else {
      if {$objets($indObjet,posX) < [expr {0 - $largImage}]} {
        set objets($indObjet,posX) $TAILLE
      }
  }
}


