global couleurs
global polices

set couleurs(PoliceTitreJeu) "#ffff00"
set couleurs(PoliceScoresJeu) "#ffffff"
set couleurs(PoliceCommentaire) "#ffffff"
set couleurs(FondFenetreJeu) "#007700"
set couleurs(FondSelectionne) "#ffff00"
set couleurs(FondNonSelectionne) "#FFFFFF"
set polices(TitreJeu) [font create -family Courier -size [expr {$PARAM(taillePoliceBase) + 6}] -weight bold -underline true]
set polices(ScoresJeu) [font create -family Courier -size $PARAM(taillePoliceBase) -slant italic]
set polices(Commentaire) [font create -family Courier -size [expr {$PARAM(taillePoliceBase) + 1}] -weight bold -slant italic]


global titreJeu
set titreJeu "!!! Titre !!!"

global nomActionTirage
set nomActionTirage "Tirer"

global scoreJoueur
set scoreJoueur ""

global quiCommence
set quiCommence ""

global scorePc
set scorePc ""

global joueurCourant
set joueurCourant 0

global imagesFaces
catch {unset imagesFaces}
array set imagesFaces [list]

global montantGagne
global montantPerd
set montantGagne 1
set montantPerd 1

global delaiAvantEfface
set delaiAvantEfface 2000

proc lblAideJeu {} {
  msgBox "But du jeu : Obtenir plus de points que l'adversaire virtuel." "Aide"
}

proc initAfficheJeu {} {
  global couleurs
  global polices
  global listeOutilsHasard
  global titreJeu
  global montantGagne
  global montantPerd
  global imagesFaces
  global nbOutilsHasard
  global outils
#global nomActionTirage
  global PARAM

  destroy .frmJeu
  frame .frmJeu -background $couleurs(FondFenetreJeu)
  ajouterLigneVideHaut frmJeu $couleurs(FondFenetreJeu)
  ajouterLigneVideBas frmJeu $couleurs(FondFenetreJeu)

  ajouterLabel frmJeu lblTitre "$titreJeu" $polices(TitreJeu) $couleurs(FondFenetreJeu) $couleurs(PoliceTitreJeu) "top"
  ajouterFrame frmJeu frmVideApresTitre $couleurs(FondFenetreJeu)

  ajouterLabel frmJeu lblCommentaire "" $polices(Commentaire) $couleurs(FondFenetreJeu) $couleurs(PoliceCommentaire) ""

  ajouterFrame frmJeu frmTirage $couleurs(FondFenetreJeu)
  set colonne 0
  for {set indOutil 1} {$indOutil <= $nbOutilsHasard} {incr indOutil} {
#      incr nbFacesTot [llength $listeOutilsHasard($indOutil,faces)]
#      incr nbFacesAMiserTot $outils($indOutil,nbFacesAMiserMax)
    for {set indFace 1} {$indFace <= $outils($indOutil,nbFacesATirer)} {incr indFace} {
      incr colonne
      set outils($indOutil,$indFace,valeur) ""
      label .frmJeu.frmTirage.outil$indOutil,$indFace -background $couleurs(FondFenetreJeu)
#        .frmJeu.frmTirage.outil$indOutil,$indFace configure -width 2
      majAfficheJeu $indOutil $indFace
      grid .frmJeu.frmTirage.outil$indOutil,$indFace -column $colonne -row 1 -padx 5 ;#-sticky w
    }
  }
  ajouterBoutton frmJeu cmdTirer "Miser et jouer !" {lancerPartie} ""

  ajouterLabel frmJeu lblGains "" $polices(ScoresJeu) $couleurs(FondFenetreJeu) $couleurs(PoliceScoresJeu) bottom

  set labelExplMises "$montantPerd $PARAM(unite) la mise ; gagne $montantGagne $PARAM(unite)"

  ajouterLabel frmJeu lblMises "$labelExplMises" $polices(ScoresJeu) $couleurs(FondFenetreJeu) $couleurs(PoliceScoresJeu) bottom

  pack .frmJeu -expand 1 -fill both

  afficherFrame frmJeu
}

proc commenter {msg {pause 0}} {
  .frmJeu.lblCommentaire configure -text "$msg"
  update
  if {$pause > 0} {
    pause $pause
  }
}

proc vider {} {
  global outils
  global nbOutilsHasard

  for {set indOutil 1} {$indOutil <= $nbOutilsHasard} {incr indOutil} {
      for {set indFace 1} {$indFace <= $outils($indOutil,nbFacesATirer)} {incr indFace} {
        set outils($indOutil,$indFace,valeur) ""
        majAfficheJeu $indOutil $indFace
      }
  }
}

set bloque false
proc commencerJeu {} {
  global couleurs
  global scoreJoueur
  global scorePc
  global bloque

  vider

#  set faceMisee ""
  set scoreJoueur ""
  set scorePc ""
  set bloque false
  commenter ""

  majNomsEtScores .frmJeu.lblGains

  .frmJeu.cmdTirer configure -text "Miser et jouer !" -command {lancerPartie}
}

proc lancerPartie {} {
  global joueurCourant
  global nomActionTirage
  global montantPerd
global quiCommence

  .frmJeu.cmdTirer configure -text "$nomActionTirage" -command {tirer}

      perdre $montantPerd 1
      majNomsEtScores .frmJeu.lblGains
      incrementerStats "montant investi" false $montantPerd

if {$quiCommence == ""} {
  if {[expr {rand()*2}] < 1} {
    set quiCommence 0 ;# pc
  } else {
    set quiCommence 1 ;# joueur
  }
} else {
}
  set joueurCourant $quiCommence

  if {$joueurCourant == 0} {
    # pc
    .frmJeu.cmdTirer configure -state disabled
    commenter "Je commence..." 1500
    jouer
  } else {
    # joueur
    commenter "Vous commencez :"
  }
}

proc tirer {} {
  global scoreJoueur
  global scorePc
  global joueurCourant
  global montantGagne
  global montantPerd
  global titreJeu
  global challenge
  global delaiAvantEfface
  global bloque
  global outils
  global nbOutilsHasard
  global quiCommence

  if {! $bloque} {
    set bloque true
    animer
    set somme 0
    for {set indOutil 1} {$indOutil <= $nbOutilsHasard} {incr indOutil} {
      for {set indFace 1} {$indFace <= $outils($indOutil,nbFacesATirer)} {incr indFace} {
        set outils($indOutil,$indFace,valeur) [tirerOutilAvecRemise $indOutil]
        incr somme [valeurFace $outils($indOutil,$indFace,valeur)]
        majAfficheJeu $indOutil $indFace
      }
    }
    if {$joueurCourant == 0} {
      set scorePc $somme
    } else {
      set scoreJoueur $somme
    }
    if {$scoreJoueur != "" && $scorePc != ""} {
      if {$scoreJoueur > $scorePc} {
        # gagn
        if {$joueurCourant == 1} {
          commenter "$scoreJoueur, bien jou !"
        } else {
          commenter "$scorePc, pas suffisant... Bravo !"
        }
        gagner $montantGagne 1
        majNomsEtScores .frmJeu.lblGains
        incrementerStats "total gains" false $montantGagne
set quiCommence 1 ;# le joueur a gagn => il rejoue
      }
      if {$scoreJoueur == $scorePc} {
        # galit
        commenter "Egalit !"
        gagner $montantPerd 1
        majNomsEtScores .frmJeu.lblGains
      }
      if {$scoreJoueur < $scorePc} {
        # perdu
        if {$joueurCourant == 1} {
          commenter "$scoreJoueur, dommage..."
        } else {
          commenter "$scorePc, j'ai gagn !"
        }
set quiCommence 0 ;# le joueur a perdu => pc commence
      }
sauverStats
      if {$challenge} {
        Challenge_JeuSuivant
      } else {
        pause $delaiAvantEfface
        commencerJeu
      }
    } else {
      set bloque false
      joueurSuivant
      if {$joueurCourant == 0} {
        .frmJeu.cmdTirer configure -state disabled
        commenter "A mon tour... (score  battre : $scoreJoueur)" 1000
      } else {
        commenter "A vous... (score  battre : $scorePc)"
      }
      jouer
    }
  }
}

proc joueurSuivant {} {
  global joueurCourant

  incr joueurCourant
  if {$joueurCourant > 1} {
    set joueurCourant 0
  }
pause 1500
vider
}

proc jouer {} {
  global scorePc

  if {$scorePc == ""} {
    tirer
    .frmJeu.cmdTirer configure -state normal
  }
}

proc valeurFace {face} {
  return [expr {0+$face}]
}

proc animer {} {
}

proc animerALaSuite {delai nbIter} {
  global nbOutilsHasard
  global outils
  global listeOutilsHasard

    for {set indOutil 1} {$indOutil <= $nbOutilsHasard} {incr indOutil} {
        set outils($indOutil,iter) 0
        set outils($indOutil,nbFaces) [llength $$listeOutilsHasard($indOutil,faces)]
    }

  for {set i 0} {$i < $nbIter} {incr i} {
    for {set indOutil 1} {$indOutil <= $nbOutilsHasard} {incr indOutil} {
      for {set indFace 1} {$indFace <= $outils($indOutil,nbFacesATirer)} {incr indFace} {
        set outils($indOutil,$indFace,valeur) [lindex $listeOutilsHasard($indOutil,faces) $outils($indOutil,iter)]
        majAfficheJeu $indOutil $indFace
        set outils($indOutil,iter) [expr {$outils($indOutil,iter) + 1}]
        if {$outils($indOutil,iter) >= $outils($indOutil,nbFaces)} {
          set outils($indOutil,iter) 0
        }
      }
    }
    pause $delai
  }
}

proc animerAuHasard {delai nbIter} {
  global nbOutilsHasard
  global outils

  for {set i 0} {$i < $nbIter} {incr i} {
    for {set indOutil 1} {$indOutil <= $nbOutilsHasard} {incr indOutil} {
      for {set indFace 1} {$indFace <= $outils($indOutil,nbFacesATirer)} {incr indFace} {
        set outils($indOutil,$indFace,valeur) [tirerOutilAvecRemise $indOutil]
        majAfficheJeu $indOutil $indFace
      }
    }
    pause $delai
  }
}



proc majAfficheJeu {indOutil indFace} {
  global imagesFaces
  global couleurs
  global listeOutilsHasard
  global nbOutilsHasard
  global outils

  if {$indOutil >= 1 && $indFace >= 1} {
    set imageFace ""
    catch {set imageFace $imagesFaces($outils($indOutil,$indFace,valeur))}
    if {$imageFace != ""} {
      .frmJeu.frmTirage.outil$indOutil,$indFace configure -image $imageFace -text ""
    } else {
      .frmJeu.frmTirage.outil$indOutil,$indFace configure -text "$outils($indOutil,$indFace,valeur)" -image ""
    }
  }

  update
}
