global nbOutils
set nbOutils 0
global outils
set outils(0) ""
global nbCoups
set nbCoups 0
global nbCoupsMax
set nbCoupsMax 1
global carMarqueCoup
set carMarqueCoup "X"
global nbTours
set nbTours -1 ;# on suppose qu'il faut remplir toute la grille
global cocheGrilleAuto
set cocheGrilleAuto false

global couleurs
global polices
global PARAM

set couleurs(PoliceTitreJeu) "#ffff00"
set couleurs(PoliceScoresJeu) "#ffffff"
set couleurs(FondFenetreJeu) "#007700"
set couleurs(FondOutilSelectionne) "#ffff00"
set couleurs(FondOutilNonSelectionne) "#FFFFFF"
set polices(TitreJeu) [font create -family Courier -size [expr {$PARAM(taillePoliceBase) + 4}] -weight bold -underline true]
set polices(ScoresJeu) [font create -family Courier -size $PARAM(taillePoliceBase) -slant italic]
set polices(MarqueCoup) [font create -family Courier -size $PARAM(taillePoliceBase) -weight bold]

global imagesFaces

global titreJeu
set titreJeu "Jeu grille"
global nomActionTirage
set nomActionTirage "Tirer"

global montantPerd
set montantPerd 0

global labelExplMises
set labelExplMises ""

proc lblEsperanceMathematique {} {
  msgBox "Le calcul de l'esprance mathmatique n'est pas encore implment dans Jeux_Grille.tcl..." "Esprance mathmatique"
}

proc lblAideJeu {} {
  msgBox "But du jeu : Remplir (totalement ou partiellement) la grille des gains et gagner les scores indiqus." "Aide"
}

proc initAfficheJeu {} {
  global titreJeu
  global nomActionTirage
  global outils
  global nbOutils
  global couleurs
  global polices
  global grille
  global labelExplMises
  global cocheGrilleAuto
  global nbCoupsMax

  destroy .frmJeu
  frame .frmJeu -background $couleurs(FondFenetreJeu)
  ajouterLigneVideHaut frmJeu $couleurs(FondFenetreJeu)
  ajouterLigneVideBas frmJeu $couleurs(FondFenetreJeu)

  ajouterLabel frmJeu lblTitre "$titreJeu" $polices(TitreJeu) $couleurs(FondFenetreJeu) $couleurs(PoliceTitreJeu) "top"
  ajouterFrame frmJeu frmVideApresTitre $couleurs(FondFenetreJeu)

  frame .frmJeu.frmGrille -background $couleurs(FondFenetreJeu)
  pack .frmJeu.frmGrille -side left
  for {set i 1} {$i <= $grille(taille)} {incr i} {
    label .frmJeu.frmGrille.lblGrille$i -text "$grille($i,libelle)" -font $polices(ScoresJeu) -background $couleurs(FondFenetreJeu) -foreground $couleurs(PoliceTitreJeu)
    grid .frmJeu.frmGrille.lblGrille$i -column 1 -row $i
    button .frmJeu.frmGrille.cmdGrille$i -text "" -width 3 -font $polices(ScoresJeu)
    if {$grille($i,action) != "" && ! $cocheGrilleAuto} {
      .frmJeu.frmGrille.cmdGrille$i configure -command "choisirCaseGrille $i" 
    } else {
      .frmJeu.frmGrille.cmdGrille$i configure -background $couleurs(FondFenetreJeu) -activebackground $couleurs(FondFenetreJeu) \
             -foreground $couleurs(PoliceScoresJeu) -relief flat
    }
    grid .frmJeu.frmGrille.cmdGrille$i -column 2 -row $i
  }

  frame .frmJeu.frmTirage -background $couleurs(FondFenetreJeu)

  if {$nbCoupsMax > 1} {
    ajouterFrame frmJeu.frmTirage frmCoups $couleurs(FondFenetreJeu)
    for {set i 1} {$i <= $nbCoupsMax} {incr i} {
#    ajouterLabel frmJeu.frmTirage.frmCoups lblCoups$i "" $polices(ScoresJeu) $couleurs(FondOutilSelectionne) $couleurs(FondOutilNonSelectionne) "left"
      label .frmJeu.frmTirage.frmCoups.lblCoups$i -text " " \
          -background $couleurs(FondOutilSelectionne) -font $polices(MarqueCoup) \
          -foreground $couleurs(FondOutilNonSelectionne) ;#-width 1
      grid .frmJeu.frmTirage.frmCoups.lblCoups$i -column $i -row 1 -padx 5 -pady 15
    }
  }

  ajouterFrame frmJeu.frmTirage frmOutils $couleurs(FondFenetreJeu)
  for {set i 1} {$i <= $nbOutils} {incr i} {
    set outils($i,valeur) ""
    set outils($i,garde) false
    button .frmJeu.frmTirage.frmOutils.cmdOutil$i -command "cliquerOutil $i" 
    majAfficheJeu $i
    grid .frmJeu.frmTirage.frmOutils.cmdOutil$i -column $i -row 1 -padx 5 -pady 5
  }
  ajouterBoutton frmJeu.frmTirage cmdTirer "$nomActionTirage" {tirer} ""
  if {$cocheGrilleAuto && $nbCoupsMax > 1} {
    ajouterBoutton frmJeu.frmTirage cmdFinTour "Ok !" {cocheGrilleAuto} ""
  }
#  ajouterBoutton frmJeu.frmTirage cmdNew "Recommencer" {commencerJeu} ""

  ajouterLabel frmJeu.frmTirage lblMises "$labelExplMises" $polices(ScoresJeu) $couleurs(FondFenetreJeu) $couleurs(PoliceScoresJeu) bottom
  ajouterLabel frmJeu.frmTirage lblGains "" $polices(ScoresJeu) $couleurs(FondFenetreJeu) $couleurs(PoliceScoresJeu) bottom
  majNomsEtScores .frmJeu.frmTirage.lblGains

  pack .frmJeu.frmTirage -side right -expand true

  afficherFrame frmJeu
}

proc commencerJeu {} {
  global montantPerd
  global outils
  global nbOutils
  global couleurs
  global nbCoupsMax
  global nbCoups
  global bloque
  
  set bloque false
  set nbCoups 0

  if {[termine]} {
    effacerPointsGrille
  }

  if {$nbCoupsMax > 1} {
    for {set i 1} {$i <= $nbCoupsMax} {incr i} {
      .frmJeu.frmTirage.frmCoups.lblCoups$i configure -text " "
    }
  }

  for {set i 1} {$i <= $nbOutils} {incr i} {
    set outils($i,valeur) ""
    set outils($i,garde) false
    majAfficheJeu $i
  }
}

proc tirer {} {
  global nbOutils
  global outils
  global nbCoups
  global nbCoupsMax
  global cocheGrilleAuto
  global montantPerd
  global carMarqueCoup
  global bloque

  if {!$bloque} {
    set bloque true
    if {$nbCoups < $nbCoupsMax} {
      if {$nbCoups == 0} {
        perdre $montantPerd 1
        majNomsEtScores .frmJeu.frmTirage.lblGains
        incrementerStats "montant investi" false $montantPerd
      }
      incr nbCoups
      animer
      for {set i 1} {$i <= $nbOutils} {incr i} {
        if {! $outils($i,garde)} {
          set outils($i,valeur) [tirerOutilAvecRemise $i]
          majAfficheJeu $i
#incrementerStats $outils($i,valeur) false
        }
      }
      if {$nbCoupsMax > 1} {
        .frmJeu.frmTirage.frmCoups.lblCoups$nbCoups configure -text "$carMarqueCoup"
        update
      }
  
      if {$nbCoups == $nbCoupsMax && $cocheGrilleAuto} {
        pause 1000
        set bloque false
        cocheGrilleAuto
      }
    } else {
      majNomsEtScores .frmJeu.frmTirage.lblGains
    }
    set bloque false
  }
}


proc cocheGrilleAuto {} {
  msgBox "cocheGrilleAuto non implmente dans Jeux_Grille.tcl"
}

proc majAfficheJeu {{indice -1}} {
  global outils
  global nbOutils
  global couleurs
  global imagesFaces
#msgBox $imagesFaces(1)
  if {$indice >= 0} {
    .frmJeu.frmTirage.frmOutils.cmdOutil$indice configure -text "" -image "" -activebackground $couleurs(FondOutilNonSelectionne)
    set imageFace ""
    catch {set imageFace $imagesFaces($outils($indice,valeur))}
    if {$imageFace != ""} {
      .frmJeu.frmTirage.frmOutils.cmdOutil$indice configure -image $imageFace ;#-text "[lblAvantRes][lblApresRes]"
    } else {
      .frmJeu.frmTirage.frmOutils.cmdOutil$indice configure -text "$outils($indice,valeur)"
    }
#.frmJeu.frmTirage.frmDes.cmdDe$indice configure -text "$des($indice,valeur)"
    if {$outils($indice,garde)} {
      .frmJeu.frmTirage.frmOutils.cmdOutil$indice configure -background $couleurs(FondOutilSelectionne)
    } else {
      .frmJeu.frmTirage.frmOutils.cmdOutil$indice configure -background $couleurs(FondOutilNonSelectionne)
    }
  } else {
    for {set i 1} {$i <= $nbOutils} {incr i} {
      majAfficheJeu $i
    }
  }
}

proc cliquerOutil {indice} {
  global outils
  global couleurs
  global nbCoupsMax
  global bloque

  if {$nbCoupsMax > 1 && !$bloque} {
    # on peut lancer plusieurs fois => on peut garder des outils :
    set outils($indice,garde) [expr (! $outils($indice,garde))]
    majAfficheJeu $indice
  }
}

proc valeurFace {val} {
  return $val
}

proc listeFacesOrdre {} {
  global outils
  global nbOutils

  set listeFaces [list]

  for {set i 1} {$i <= $nbOutils} {incr i} {
    lappend listeFaces [valeurFace $outils($i,valeur)]
  }
  return [lsort $listeFaces]
}

proc sommeFaces {{lblFace ""}} {
  global outils
  global nbOutils

  set points 0

  for {set i 1} {$i <= $nbOutils} {incr i} {
    if {$outils($i,valeur) == $lblFace || $lblFace == ""} {
      set points [expr {$points + $outils($i,valeur)}]
    }
  }
  return $points
}

proc si {condition pointsOk {pointsKo 0}} {
  if {$condition} {
    return $pointsOk
  } else {
    return $pointsKo
  }
}

proc SuiteDe {nbFacesSuite} {
msgBox "proc SuiteDe non implmente dans Jeux_Grille.tcl"
  return false
}

proc verifie {format} {
  set long [string length $format]
  set nbCherche(0) 0
  for {set i 0} {$i < $long} {incr i} {
    set car [string index $format $i]
    if {[lsearch [array names nbCherche] $car] == -1} {
      set nbCherche($car) 0
    }
    set nbCherche($car) [expr {$nbCherche($car) + 1}]
  }

  set faces [listeFacesOrdre]
  set nbFaces(0) 0
  foreach face $faces {
    if {[lsearch [array names nbFaces] $face] == -1} {
      set nbFaces($face) 0
    }
    set nbFaces($face) [expr {$nbFaces($face) + 1}]
  }

  set ok true
  set taille [llength $faces]
  foreach {face nbMin} [array get nbCherche] {
    if {$ok} {
    set i 0
    set continuer true
    while {$continuer} {
      set faceTest [lindex $faces $i]
      if {$nbFaces($faceTest) >= $nbMin} {
        set nbFaces($faceTest) [expr {$nbFaces($faceTest) - $nbMin}]
        set continuer false
      } else {
        incr i
        if {$i >= $taille} {
          set continuer false
          set ok false
        }
      }
    }
    }
  }
  return $ok
}


proc obtenu {facesCherchees} {
  set nbCherche(0) 0

  set faces [listeFacesOrdre]
  set nbFaces(0) 0
  foreach face $faces {
    if {[lsearch [array names nbFaces] $face] == -1} {
      set nbFaces($face) 0
    }
    set nbFaces($face) [expr {$nbFaces($face) + 1}]
    if {[lsearch [array names nbCherche] $face] == -1} {
      set nbCherche($face) 0
    }
  }

  set long [string length $facesCherchees]
  for {set i 0} {$i < $long} {incr i} {
    set car [string index $facesCherchees $i]
    if {[lsearch [array names nbCherche] $car] == -1} {
      set nbCherche($car) 0
    }
    set nbCherche($car) [expr {$nbCherche($car) + 1}]
    if {[lsearch [array names nbFaces] $car] == -1} {
      set nbFaces($car) 0
    }
  }

  set ok true
  set taille [llength $faces]
  foreach {face nbMin} [array get nbCherche] {
    if {$ok} {
      if {$nbFaces($face) < $nbMin} {
        set continuer false
        set ok false
      }
    }
  }
  return $ok
}

proc contient {liste valeur} {
  return [expr {[lsearch $liste $valeur] >= 0}]
}


global grille
set grille(taille) 0

proc majTotaux {{dernierGain 0}} {
  gagner $dernierGain 1
  majNomsEtScores .frmJeu.frmTirage.lblGains
}

proc gainSpecial {gainInitial} {
  return $gainInitial
}

proc choisirCaseGrille {indLigne {pause 0}} {
  global grille
  global couleurs
  global challenge
  global outils
  global bloque
  
  if {!$bloque} {
    if {$outils(1,valeur) != "" && $indLigne > 0} {
      set grille($indLigne,score) [eval "$grille($indLigne,action)"]
      # on autorise un ventuel gain spcial
      set grille($indLigne,score) [gainSpecial $grille($indLigne,score)]
      .frmJeu.frmGrille.cmdGrille$indLigne configure -text "$grille($indLigne,score)" \
               -background $couleurs(FondFenetreJeu) -activebackground $couleurs(FondFenetreJeu) \
               -foreground $couleurs(PoliceScoresJeu) \
               -relief flat -command ""
      majTotaux $grille($indLigne,score)
      update
  incrementerStats "nb $grille($indLigne,libelle)" false
  incrementerStats "total gains" false $grille($indLigne,score)
  incrementerStats "nb parties" true
    }
    if {$pause > 0} {
      pause $pause
    }
    if {[termine] && $challenge} {
      Challenge_JeuSuivant
    } else {
      commencerJeu
    }
  }
}

proc termine {} {
  global grille
  global nbTours

  set i 1
  set nbRemplies 0
  set continuer true
  set termine true
  while {$continuer} {
    if {$grille($i,action) != ""} {
      if {$grille($i,score) == ""} {
        # cette case n'est pas remplie
        if {$nbTours < 0} {
          # on est cens terminer la grille
          set continuer false
          set termine false
        }
      } else {
        incr nbRemplies
        if {$nbTours > 0} {
          if {$nbRemplies >= $nbTours} {
            # quotas rempli !
            set continuer false
            set termine true
          }
        }
      }
    }
    incr i
    if {$i > $grille(taille)} {
      set continuer false
    }
  }
  return $termine
}

proc creerGrilleFichier {nomFichier} {
  creerGrilleListe [lireFichierDansListe $nomFichier]
}
proc creerGrilleChaine {chaine} {
  creerGrilleChaine [split $chaine "\n"]
}
proc creerGrilleListe {lignes} {
  global grille
  global PARAM

  set grille(taille) 0
  foreach ligne $lignes {
    set grille(taille) [expr {$grille(taille) + 1}]

    if [string match "*<*>*" $ligne] {
      set libelle [string range $ligne 0 [expr {[string first "<" $ligne]-1}]]
      set libelle [string trim $libelle]
      set commande [string range $ligne [expr {[string first "<" $ligne]+1}] [expr {[string first ">" $ligne]-1}]]
      set commande [string trim $commande]
      set grille($grille(taille),libelle) "[subst $libelle]"
      set grille($grille(taille),action) "$commande"
    } else {
      set grille($grille(taille),libelle) "$ligne"
      set grille($grille(taille),action) ""
    }
    set grille($grille(taille),score) ""
  }
}

proc effacerPointsGrille {} {
  global grille
  global nbCoupsMax

  for {set i 1} {$i <= $grille(taille)} {incr i} {
    set grille($i,score) ""
  }
  majAfficheGrille
  if {$nbCoupsMax > 1} {
    for {set i 1} {$i <= $nbCoupsMax} {incr i} {
      .frmJeu.frmTirage.frmCoups.lblCoups$i configure -text " "
    }
  }
update
}

proc majAfficheGrille {} {
  global grille
  global polices
  global couleurs
  global cocheGrilleAuto

  for {set i 1} {$i <= $grille(taille)} {incr i} {
    destroy .frmJeu.frmGrille.cmdGrille$i
    button .frmJeu.frmGrille.cmdGrille$i -text "$grille($i,score)" -width 3 -font $polices(ScoresJeu)
    if {$grille($i,action) != "" && ! $cocheGrilleAuto} {
      .frmJeu.frmGrille.cmdGrille$i configure -command "choisirCaseGrille $i" 
    } else {
      .frmJeu.frmGrille.cmdGrille$i configure -background $couleurs(FondFenetreJeu) -activebackground $couleurs(FondFenetreJeu) \
             -foreground $couleurs(PoliceScoresJeu) -relief flat
    }
    grid .frmJeu.frmGrille.cmdGrille$i -column 2 -row $i
  }
}

proc animer {} {
}

proc animerALaSuite {delai nbIter} {
  global listeOutilsHasard
  global nbOutils
  global outils

  for {set i 1} {$i <= $nbOutils} {incr i} {
    set listeFaces($i) $listeOutilsHasard($i,faces)
    set nbFaces($i) [llength $listeFaces($i)]
    set indFace($i) 0
  }
  for {set i 0} {$i < $nbIter} {incr i} {
    for {set j 1} {$j <= $nbOutils} {incr j} {
      if {! $outils($j,garde)} {
        set outils($j,valeur) [lindex $listeFaces($j) $indFace($j)]
        majAfficheJeu $j
        set indFace($j) [expr {$indFace($j) + 1}]
        if {$indFace($j) >= $nbFaces($j)} {
          set indFace($j) 0
        }
      }
    }
    pause $delai
  }
}

proc animerAuHasard {delai nbIter} {
  global nbOutils
  global outils

  for {set i 0} {$i < $nbIter} {incr i} {
    for {set j 1} {$j <= $nbOutils} {incr j} {
      if {! $outils($j,garde)} {
        set outils($j,valeur) [tirerOutilAvecRemise $j]
        majAfficheJeu $j
      }
    }
update
    pause $delai
  }
}
