global nbTirages
set nbTirages 0
global outils
set outils(0,nbFacesATirer) 0
set outils(0,nbFacesAMiserMax) 0
global grillesJouees
set grillesJouees(nb) 0
set grillesJouees(0,outil0) [list]
global grilleCourante
set grilleCourante(outil0) [list]
global nbGrillesMax
set nbGrillesMax 0
global effacerGrillesApresTirage
set effacerGrillesApresTirage true
#global nbFacesParGrille
#set nbFacesParGrille 0

global couleurs
global polices
global PARAM

set couleurs(PoliceTitreJeu) "#ffff00"
set couleurs(PoliceScoresJeu) "#ffffff"
set couleurs(FondFenetreJeu) "#007700"
set couleurs(FondFaceSelectionnee) "#ffff00"
set couleurs(FondFaceNonSelectionnee) "#FFFFFF"
set couleurs(PoliceFaceTirage) "#000000"
set polices(TitreJeu) [font create -family Courier -size [expr {$PARAM(taillePoliceBase) + 4}] -weight bold -underline true]
set polices(ScoresJeu) [font create -family Courier -size $PARAM(taillePoliceBase) -slant italic]
set polices(ResultatTirage) [font create -family Courier -size $PARAM(taillePoliceBase)]

global imagesFaces

global titreJeu
set titreJeu "Jeu loterie"
global nomActionTirage
set nomActionTirage "Tirer"

global montantPerd
set montantPerd 0

global labelExplMises
set labelExplMises ""

global challengeDelaiAttente
set challengeDelaiAttente 0 ;# pas d'attente !

global aJoue
set aJoue false

proc lblEsperanceMathematique {} {
  msgBox "Le calcul de l'esprance mathmatique n'est pas encore implment dans Jeux_Loterie.tcl..." "Esprance mathmatique"
}

proc lblAideJeu {} {
  msgBox "But du jeu : Choisir ses grilles et esprer obtenir un nombre maximum de faces tires" "Aide"
}

proc initAfficheJeu {} {
  global outils
  global nbTirages
  global nbGrillesMax
  global listeOutilsHasard
  global nbOutilsHasard

  global titreJeu
  global nomActionTirage
  global labelExplMises
  global couleurs
  global polices

  destroy .frmJeu
  frame .frmJeu -background $couleurs(FondFenetreJeu)
  ajouterLigneVideHaut frmJeu $couleurs(FondFenetreJeu)
  ajouterLigneVideBas frmJeu $couleurs(FondFenetreJeu)

  ajouterLabel frmJeu lblTitre "$titreJeu" $polices(TitreJeu) $couleurs(FondFenetreJeu) $couleurs(PoliceTitreJeu) "top"


  for {set indTirage 1} {$indTirage <= $nbTirages} {incr indTirage} {
    # pour chaque tirage,
    ajouterFrame frmJeu frmTirage$indTirage $couleurs(FondFenetreJeu)
    if {$nbTirages > 1} {
      label .frmJeu.frmTirage$indTirage.lblTirage -text "Tir. $indTirage : " \
              -background $couleurs(FondFenetreJeu) -foreground $couleurs(PoliceScoresJeu) \
              -font $polices(ScoresJeu) ;#-width 2
      grid .frmJeu.frmTirage$indTirage.lblTirage -column 1 -row 1 ;#-sticky w
    }
    set colonne 1
    set nbFacesTot 0
    set nbFacesAMiserTot 0
    for {set indOutil 1} {$indOutil <= $nbOutilsHasard} {incr indOutil} {
      incr nbFacesTot [llength $listeOutilsHasard($indOutil,faces)]
      incr nbFacesAMiserTot $outils($indOutil,nbFacesAMiserMax)
      for {set indFace 1} {$indFace <= $outils($indOutil,nbFacesATirer)} {incr indFace} {
        incr colonne
        if {$indFace == [expr {$outils($indOutil,nbFacesAMiserMax) + 1}]} {
          label .frmJeu.frmTirage$indTirage.lblSeparCompl -text "/" \
              -background $couleurs(FondFenetreJeu) -foreground $couleurs(PoliceScoresJeu) \
              -font $polices(ScoresJeu) -width 2
          grid .frmJeu.frmTirage$indTirage.lblSeparCompl -column $colonne -row 1 -sticky w
          incr colonne
        }

        set outils($indTirage,$indOutil,$indFace,valeur) ""
        label .frmJeu.frmTirage$indTirage.outil$indOutil,$indFace -font $polices(ResultatTirage)
        .frmJeu.frmTirage$indTirage.outil$indOutil,$indFace configure -width 2
        majAfficheJeu $indTirage $indOutil $indFace
        grid .frmJeu.frmTirage$indTirage.outil$indOutil,$indFace -column $colonne -row 1 -padx 5 ;#-sticky w
      }
    }
  }
  ajouterBoutton frmJeu cmdTirer "$nomActionTirage" {tirer} ""
  .frmJeu.cmdTirer configure -font $polices(ResultatTirage)

  ajouterFrame frmJeu frmGrille $couleurs(FondFenetreJeu)
  set nbLignes $nbGrillesMax

  set sticky "w"
set tailleLabel [expr {$nbFacesAMiserTot * 3 + 1}]
set libelle "Vos grilles :"
if {$tailleLabel < [string length $libelle]} {
  set tailleLabel [string length $libelle]
}
  label .frmJeu.frmGrille.lblJouees -text $libelle \
        -background $couleurs(FondFenetreJeu) -foreground $couleurs(PoliceScoresJeu) \
        -font $polices(ScoresJeu) -width $tailleLabel
  grid .frmJeu.frmGrille.lblJouees -column 1 -row 1 -sticky $sticky
  incr nbLignes
  set nbColonnes [expr {int($nbFacesTot / $nbGrillesMax) + 1}]
  set indColonneMax $nbColonnes
  for {set indGrille 1} {$indGrille <= $nbGrillesMax} {incr indGrille} {
    label .frmJeu.frmGrille.lblGrille$indGrille -text "" \
        -background $couleurs(FondFenetreJeu) -foreground $couleurs(PoliceScoresJeu) \
        -font $polices(ScoresJeu) -height 1
    grid .frmJeu.frmGrille.lblGrille$indGrille -column 1 -row [expr {$indGrille + 1}] -sticky $sticky -pady 4
  }
  label .frmJeu.frmGrille.lblGains -text "" \
        -background $couleurs(FondFenetreJeu) -foreground $couleurs(PoliceScoresJeu) \
        -font $polices(ScoresJeu)
  grid .frmJeu.frmGrille.lblGains -column 1 -row [expr {$indGrille + 1}]
  majNomsEtScores .frmJeu.frmGrille.lblGains

  label .frmJeu.frmGrille.lblExpl -text "$labelExplMises" \
        -background $couleurs(FondFenetreJeu) -foreground $couleurs(PoliceScoresJeu) \
        -font $polices(ScoresJeu)
  grid .frmJeu.frmGrille.lblExpl -column 1 -row [expr {$indGrille + 2}]

  frame .frmJeu.frmGrille.frmCocheFaces -background $couleurs(FondFenetreJeu)
  afficherGrilleChoix

  set indLigne 1
  set indColonne 1
  for {set indOutil 1} {$indOutil <= $nbOutilsHasard} {incr indOutil} {
    set nbFacesOutil [llength $listeOutilsHasard($indOutil,faces)]
    for {set indFace 0} {$indFace < $nbFacesOutil} {incr indFace} {
      button .frmJeu.frmGrille.frmCocheFaces.cmdFace$indOutil,$indFace -command "choisir $indOutil $indFace" \
           -text [lindex $listeOutilsHasard($indOutil,faces) $indFace] -font $polices(ScoresJeu) \
           -width 2 -background $couleurs(FondFaceNonSelectionnee)
      grid .frmJeu.frmGrille.frmCocheFaces.cmdFace$indOutil,$indFace -column $indColonne -row $indLigne ;#-padx 5
      incr indColonne
      if {$indColonne > $indColonneMax} {
        set indColonne 1
        incr indLigne
      }
    }
    set indColonne 1
    incr indLigne
  }
  button .frmJeu.frmGrille.frmCocheFaces.cmdAjouterGrille -text "Valider cette grille" -command "ajouterGrille"
  grid .frmJeu.frmGrille.frmCocheFaces.cmdAjouterGrille -column 1 -row $indLigne -columnspan $nbColonnes

  afficherFrame frmJeu
}

proc commencerJeu {} {
  global montantPerd
  global nbTirages
  global outils
  global nbOutilsHasard
  global grilleCourante
  global grillesJouees
  global nbGrillesMax
  global effacerGrillesApresTirage
  global aJoue 
  global bloque
  
  set bloque false
  set aJoue false

  if {$effacerGrillesApresTirage} {
    set grillesJouees(nb) 0
    for {set i 1} {$i <= $nbGrillesMax} {incr i} {
      majGrillesJouees $i ""
    }
  }

  for {set indTirage 1} {$indTirage <= $nbTirages} {incr indTirage} {
    # pour chaque tirage,
    for {set indOutil 1} {$indOutil <= $nbOutilsHasard} {incr indOutil} {
      set grilleCourante(outil$indOutil) [list]
      remiseTotaleOutilHasard $indOutil
      for {set indFace 1} {$indFace <= $outils($indOutil,nbFacesATirer)} {incr indFace} {
        set outils($indTirage,$indOutil,$indFace,valeur) ""
        majAfficheJeu $indTirage $indOutil $indFace
      }
    }
  }
  update 
}

proc afficherGrilleChoix {} {
  global nbGrillesMax
  global nomActionTirage
  global challenge
  global aJoue
  global bloque

  if {!$bloque} {
    if {$challenge && $aJoue} {
      Challenge_JeuSuivant
    } else {
      destroy .frmJeu.frmGrille.frmResultats
      .frmJeu.cmdTirer configure -text "$nomActionTirage" -command tirer
      grid .frmJeu.frmGrille.frmCocheFaces -column 2 -row 2 -rowspan [expr {1 + $nbGrillesMax}] -sticky nsew
      commencerJeu
    }
  }
}

proc afficherGrilleResultats {} {
  global nbGrillesMax
  global nbTirages
  global couleurs
  global polices

  grid forget .frmJeu.frmGrille.frmCocheFaces
  frame .frmJeu.frmGrille.frmResultats -background $couleurs(FondFenetreJeu)
catch {grid anchor .frmJeu.frmGrille.frmResultats center}
  grid .frmJeu.frmGrille.frmResultats -column 2 -row 1 -rowspan [expr {1 + $nbGrillesMax}] -sticky nsew

  set txtTitreRes ""
  if {$nbTirages > 1} {
    for {set indTirage 1} {$indTirage <= $nbTirages} {incr indTirage} {
      append txtTitreRes "Tir. $indTirage"
      if {$indTirage < $nbTirages} {
        append txtTitreRes " ; "
      }
    }
  }

  label .frmJeu.frmGrille.frmResultats.lblResultats -text "  $txtTitreRes" \
        -background $couleurs(FondFenetreJeu) -foreground $couleurs(PoliceScoresJeu) \
        -font $polices(ScoresJeu) -height 1
  grid .frmJeu.frmGrille.frmResultats.lblResultats -column 1 -row 1

  for {set i 1} {$i <= $nbGrillesMax} {incr i} {
    label .frmJeu.frmGrille.frmResultats.lblRes$i -text "" \
        -background $couleurs(FondFenetreJeu) -foreground $couleurs(PoliceScoresJeu) \
        -font $polices(ScoresJeu) -height 1
    grid .frmJeu.frmGrille.frmResultats.lblRes$i -column 1 -row [expr {$i + 1}] -pady 4
  }
  label .frmJeu.frmGrille.frmResultats.lblVide -text "" \
        -background $couleurs(FondFenetreJeu) -foreground $couleurs(PoliceScoresJeu) \
        -font $polices(ScoresJeu)
  grid .frmJeu.frmGrille.frmResultats.lblVide -column 1 -row [expr {$nbGrillesMax + 1}]

  .frmJeu.cmdTirer configure -text "Ok !" -command afficherGrilleChoix

  update
}

proc tirer {} {
  global nbTirages
  global nbOutilsHasard
  global listeOutilsHasard
  global grilleCourante
  global grillesJouees
  global montantPerd
  global aJoue
  global bloque

  if {!$bloque} {
    set bloque true
    if {$grillesJouees(nb) > 0} {
      set aJoue true
      for {set indOutil 1} {$indOutil <= $nbOutilsHasard} {incr indOutil} {
        set grilleCourante(outil$indOutil) [list]
        set nbFacesOutil [llength $listeOutilsHasard($indOutil,faces)]
        for {set indFace 0} {$indFace < $nbFacesOutil} {incr indFace} {
          majAfficheGrille $indOutil $indFace
        }
      }

      incrementerStats "nb parties" false
      set investi [expr {$montantPerd * $grillesJouees(nb)}]
      perdre $investi 1
      majNomsEtScores .frmJeu.frmGrille.lblGains
      incrementerStats "montant investi" false $investi
  
      afficherGrilleResultats
      for {set indTirage 1} {$indTirage <= $nbTirages} {incr indTirage} {
        # pour chaque tirage,
        animerTirage $indTirage
      }
      calculerNbFaces
      majResultats
    } else {
      msgBox "Vous devez valider au-moins une grille" "Tirage"
    }
    set bloque false
  }
}

proc animerTirage {indTirage} {
  global nbOutilsHasard
  global outils
  global vitesseAffichage

  set nbAnim 7
  set delai 20
  set nbAnimBoucle $nbAnim
  set delaiBoucle $delai

  for {set indOutil 1} {$indOutil <= $nbOutilsHasard} {incr indOutil} {
    remiseTotaleOutilHasard $indOutil
    for {set indFace 1} {$indFace <= $outils($indOutil,nbFacesATirer)} {incr indFace} {
      # pour chaque face,
      if {$vitesseAffichage != 0} {
        for {set indAnim 1} {$indAnim <= $nbAnimBoucle} {incr indAnim} {
          # on anime toutes les faces >= $indFace
          for {set indFaceAnim $indFace} {$indFaceAnim <= $outils($indOutil,nbFacesATirer)} {incr indFaceAnim} {
            set outils($indTirage,$indOutil,$indFaceAnim,valeur) [tirerOutilAvecRemise $indOutil]
            majAfficheJeu $indTirage $indOutil $indFaceAnim
          }
          pause $delaiBoucle
        }
      }
      # puis on tire cette face :
      set outils($indTirage,$indOutil,$indFace,valeur) [tirerOutilSansRemise $indOutil]
      majAfficheJeu $indTirage $indOutil $indFace
incrementerStats $outils($indTirage,$indOutil,$indFace,valeur) false ;# sans sauver (perfs)
      incr delaiBoucle 10 ;#$delai
    }
    update 
  }
  sauverStats
}

proc majAfficheJeu {indTirage indOutil indFace} {
  global outils
  global couleurs
  global imagesFaces

    .frmJeu.frmTirage$indTirage.outil$indOutil,$indFace configure -text "" -image ""
    set imageFace ""
    catch {set imageFace $imagesFaces($outils($indice,valeur))}
    if {$imageFace != ""} {
      .frmJeu.frmTirage$indTirage.outil$indOutil,$indFace configure -image $imageFace ;#-text "[lblAvantRes][lblApresRes]"
    } else {
      .frmJeu.frmTirage$indTirage.outil$indOutil,$indFace configure -text "$outils($indTirage,$indOutil,$indFace,valeur)" \
          -background $couleurs(FondFaceSelectionnee) -foreground $couleurs(PoliceFaceTirage)
    }
}


proc majAfficheGrille {indOutil indFace} {
  global couleurs
  global grilleCourante
  global listeOutilsHasard

  set faceChoisie [lindex $listeOutilsHasard($indOutil,faces) $indFace]
  set indDansCourante [lsearch $grilleCourante(outil$indOutil) $faceChoisie]
  if {$indDansCourante >= 0} {
    .frmJeu.frmGrille.frmCocheFaces.cmdFace$indOutil,$indFace configure -background $couleurs(FondFaceSelectionnee)
  } else {
    .frmJeu.frmGrille.frmCocheFaces.cmdFace$indOutil,$indFace configure -background $couleurs(FondFaceNonSelectionnee)
  }

  update
}

proc majGrillesJouees {indGrille texte} {
  .frmJeu.frmGrille.lblGrille$indGrille configure -text "$texte"
  update
}


proc choisir {indOutil indFace} {
  global couleurs
  global listeOutilsHasard
  global grilleCourante
  global outils

  set faceChoisie [lindex $listeOutilsHasard($indOutil,faces) $indFace]
  set indDansCourante [lsearch $grilleCourante(outil$indOutil) $faceChoisie]
  if {$indDansCourante >= 0} {
    # existe dj =>  supprimer 
    set grilleCourante(outil$indOutil) [lreplace $grilleCourante(outil$indOutil) $indDansCourante $indDansCourante]
  } else {
    # on doit l'ajouter => on vrifie la taille :
    if {[llength $grilleCourante(outil$indOutil)] >= $outils($indOutil,nbFacesAMiserMax)} {
      # on supprime le premier :
      set indPremFace [lsearch $listeOutilsHasard($indOutil,faces) [lindex $grilleCourante(outil$indOutil) 0]]
      set grilleCourante(outil$indOutil) [lreplace $grilleCourante(outil$indOutil) 0 0]
      majAfficheGrille $indOutil $indPremFace
    }
    # on ajoute le nouveau !
    lappend grilleCourante(outil$indOutil) $faceChoisie
  }
  majAfficheGrille $indOutil $indFace
}

proc ajouterGrille {} {
  global grilleCourante
  global nbOutilsHasard
  global grillesJouees
  global nbGrillesMax
  global outils

  if {$grillesJouees(nb) < $nbGrillesMax} {
    set nbFacesMisees 0
    set nbFacesAttendues 0
    set grilleMisee ""
    for {set indOutil 1} {$indOutil <= $nbOutilsHasard} {incr indOutil} {
      incr nbFacesMisees [llength $grilleCourante(outil$indOutil)]
      incr nbFacesAttendues $outils($indOutil,nbFacesAMiserMax)
      set grillesJouees($grillesJouees(nb),outil$indOutil) $grilleCourante(outil$indOutil)
      append grilleMisee " " $grilleCourante(outil$indOutil)
    }
    append grilleMisee " "
    if {$nbFacesMisees == $nbFacesAttendues} {
      # ok !
      set grillesJouees(nb) [expr {$grillesJouees(nb) + 1}]
      majGrillesJouees $grillesJouees(nb) $grilleMisee
    } else {
      msgBox "Vous devez choisir $nbFacesAttendues faces" "Miser grille"
    }
  } else {
    msgBox "Vous ne pouvez pas jouer plus de $nbGrillesMax grilles" "Miser grille"
  }

}


proc calculerNbFaces {} {
  global nbTirages
  global outils
  global grillesJouees
  global nbOutilsHasard

  for {set indTirage 1} {$indTirage <= $nbTirages} {incr indTirage} {
    for {set indGrille 0} {$indGrille < $grillesJouees(nb)} {incr indGrille} {
      for {set indOutil 1} {$indOutil <= $nbOutilsHasard} {incr indOutil} {
        # chaque outil,
        set grillesJouees($indGrille,$indTirage,$indOutil,nbTrouvees) 0
        set grillesJouees($indGrille,$indTirage,$indOutil,nbTrouveesCompl) 0
      }
    }
  }

  for {set indTirage 1} {$indTirage <= $nbTirages} {incr indTirage} {
    # pour chaque tirage,
    for {set indOutil 1} {$indOutil <= $nbOutilsHasard} {incr indOutil} {
      # chaque outil,
      for {set indFace 1} {$indFace <= $outils($indOutil,nbFacesATirer)} {incr indFace} {
        # et chaque face tire,
        # on cherche cette face dans les grilles mises :
        for {set indGrille 0} {$indGrille < $grillesJouees(nb)} {incr indGrille} {
          if [contient $grillesJouees($indGrille,outil$indOutil) $outils($indTirage,$indOutil,$indFace,valeur)] {
            if {$indFace <= $outils($indOutil,nbFacesAMiserMax)} {
              set grillesJouees($indGrille,$indTirage,$indOutil,nbTrouvees) [expr {$grillesJouees($indGrille,$indTirage,$indOutil,nbTrouvees) + 1}]
            } else {
              # c'est un complmentaire
              set grillesJouees($indGrille,$indTirage,$indOutil,nbTrouveesCompl) [expr {$grillesJouees($indGrille,$indTirage,$indOutil,nbTrouveesCompl) + 1}]
            }
          }
        }
      }
    }
  }

  for {set indTirage 1} {$indTirage <= $nbTirages} {incr indTirage} {
    for {set indGrille 0} {$indGrille < $grillesJouees(nb)} {incr indGrille} {
      for {set indOutil 1} {$indOutil <= $nbOutilsHasard} {incr indOutil} {
        if {$grillesJouees($indGrille,$indTirage,$indOutil,nbTrouveesCompl) != 0} {
          set grillesJouees($indGrille,$indTirage,$indOutil,nbTrouvees) "$grillesJouees($indGrille,$indTirage,$indOutil,nbTrouvees)\/$grillesJouees($indGrille,$indTirage,$indOutil,nbTrouveesCompl)"
        }
      }
    }
  }


}

proc majResultats {} {
  global nbTirages 
  global grillesJouees
  global nbGrillesMax
  global grille
  global nbOutilsHasard
  global PARAM

  for {set indGrille 0} {$indGrille < $grillesJouees(nb)} {incr indGrille} {
    # pour chaque grille 
    set res "  "
    for {set indTirage 1} {$indTirage <= $nbTirages} {incr indTirage} {
      # chaque tirage,
      set montantGagne 0
      set nbTrouvees ""
      for {set indOutil 1} {$indOutil <= $nbOutilsHasard} {incr indOutil} {
        # et chaque outil,
        if {$indOutil > 1} {
          append nbTrouvees "+"
        }
        append nbTrouvees "$grillesJouees($indGrille,$indTirage,$indOutil,nbTrouvees)/$grillesJouees($indGrille,$indTirage,$indOutil,nbTrouveesCompl)"
      }
      catch {set montantGagne $grille($nbTrouvees)}
      if {$montantGagne != 0} {
        gagner $montantGagne 1
        majNomsEtScores .frmJeu.frmGrille.lblGains
incrementerStats "total gains" false $montantGagne
#        append res " ($montantGagne $PARAM(unite))"
      }
        append res "$montantGagne $PARAM(unite)"

      if {$indTirage < $nbTirages} {
        append res " ; "
      }
    }
    .frmJeu.frmGrille.frmResultats.lblRes[expr {$indGrille + 1}] configure -text "$res"
  }
  update 
}



proc contient {liste valeur} {
  set res [expr {[lsearch $liste $valeur] >= 0}]
  return $res
}


global grille
set grille(taille) 0

proc creerGrilleFichier {nomFichier} {
  creerGrilleListe [lireFichierDansListe $nomFichier]
}
proc creerGrilleChaine {chaine} {
  creerGrilleListe [split $chaine "\n"]
}
proc creerGrilleListe {lignes} {
  global grille
unset grille
  foreach ligne $lignes {
    if [string match "*<*>*" $ligne] {
      set formatNb [string range $ligne 0 [expr {[string first "<" $ligne]-1}]]
      set formatNb [string trim $formatNb]
      set montant [string range $ligne [expr {[string first "<" $ligne]+1}] [expr {[string first ">" $ligne]-1}]]
      set montant [string trim $montant]
      set grille($formatNb) $montant
    }
  }
}
