global couleurs
global polices

set couleurs(PoliceTitreJeu) "#ffff00"
set couleurs(PoliceScoresJeu) "#ffffff"
set couleurs(PoliceResultatTirage) "#ffffff"
set couleurs(FondFenetreJeu) "#007700"
set couleurs(FondSelectionne) "#ffff00"
set couleurs(FondNonSelectionne) "#FFFFFF"
set polices(TitreJeu) [font create -family Courier -size [expr {$PARAM(taillePoliceBase) + 6}] -weight bold -underline true]
set polices(ScoresJeu) [font create -family Courier -size $PARAM(taillePoliceBase) -slant italic]
set polices(ResultatTirage) [font create -family Courier -size [expr {$PARAM(taillePoliceBase) + 2}] -weight bold]


global titreJeu
set titreJeu "!!! Titre !!!"

global nomActionTirage
set nomActionTirage "Lancer le d !"

global facesMisees
set facesMisees [list]

global NB_LIGNES
set NB_LIGNES 1

global nbFacesMiseesMax
set nbFacesMiseesMax 1

global faceTiree
set faceTiree ""

global imagesFaces
catch {unset imagesFaces}
array set imagesFaces [list]

global montantGagne
global montantGagneMax
global montantPerd
set montantGagne 1
set montantGagneMax ""
set montantPerd 1

proc montantGagne {faceTiree} {
  global montantGagne
  return $montantGagne
}

global delaiAvantEfface
set delaiAvantEfface 2000

proc lblAvantRes {} {
  return ""
}

proc lblApresRes {} {
  return ""
}

proc lblEsperanceMathematique {} {
  global listeOutilsHasard
  global facesMisees
  global montantGagne
  global montantPerd
  global titreJeu
  global PARAM

  set nbFaces [llength $listeOutilsHasard(1,faces)]
  set nbMisees [llength $facesMisees]
  set nbPasMisees [expr {$nbFaces - $nbMisees}]
  set gainSiPerd [expr {0 - $montantPerd * $nbMisees}]
  set gainSiGagne [expr {$montantGagne + $gainSiPerd}]
#  set probaGagne [expr {(0.0 + $nbMisees) / $nbFaces}]
#  set probaPerd [expr {(0.0 + $nbPasMisees) / $nbFaces}]
#  set EM [expr {($gainSiPerd * $probaPerd) + ($gainSiGagne * $probaGagne)}]
  set EM [expr {(0.0 + ($gainSiPerd * $nbPasMisees) + ($gainSiGagne * $nbMisees)) / $nbFaces}]
  set titre [replaceAll "$titreJeu" "\n" " "]
  set labelEM "Dans \"$titre\",\nEM($nbMisees mise"
  if {$nbMisees > 1} {
    append labelEM "s"
  }
  append labelEM ") = \
    ($gainSiPerd*$nbPasMisees/$nbFaces) + ($gainSiGagne*$nbMisees/$nbFaces) = $EM $PARAM(unite)"
  msgBox $labelEM "Esprance mathmatique"
}

proc lblAideJeu {} {
  msgBox "But du jeu : Parier sur une ou plusieurs faces en esprant remporter le gain." "Aide"
}

proc initAfficheJeu {} {
  global couleurs
  global polices
  global listeOutilsHasard
  global titreJeu
  global nomActionTirage
  global nbFacesMiseesMax
  global montantGagne
  global montantPerd
  global imagesFaces
  global PARAM
global montantGagneMax
global NB_LIGNES

  destroy .frmJeu
  frame .frmJeu -background $couleurs(FondFenetreJeu)
  ajouterLigneVideHaut frmJeu $couleurs(FondFenetreJeu)
  ajouterLigneVideBas frmJeu $couleurs(FondFenetreJeu)

  ajouterLabel frmJeu lblTitre "$titreJeu" $polices(TitreJeu) $couleurs(FondFenetreJeu) $couleurs(PoliceTitreJeu) "top"
  ajouterFrame frmJeu frmVideApresTitre $couleurs(FondFenetreJeu)

  ajouterLabel frmJeu lblTirage "" $polices(ResultatTirage) $couleurs(FondFenetreJeu) $couleurs(PoliceResultatTirage) ""

  if {$nomActionTirage != ""} {
    ajouterBoutton frmJeu cmdTirer "$nomActionTirage" {tirer} ""
#  ajouterBoutton frmJeu cmdNew "Recommencer" {commencerJeu} ""
  }

  ajouterFrame frmJeu frmChoix $couleurs(FondFenetreJeu)

  set i 0
set nbFacesParLigneFloat [expr {(0.0 + [llength $listeOutilsHasard(1,faces)]) / $NB_LIGNES}]
set nbFacesParLigne [expr {int($nbFacesParLigneFloat)}]
if {$nbFacesParLigne < $nbFacesParLigneFloat} {
  incr nbFacesParLigne
}
set ligne 1
set colonne 1
  foreach face $listeOutilsHasard(1,faces) {
    button .frmJeu.frmChoix.cmd$i -command "choisir $i" -background $couleurs(FondNonSelectionne)  -activebackground $couleurs(FondNonSelectionne)

    set imageFace ""
    catch {set imageFace $imagesFaces($face)}
    if {$imageFace != ""} {
      .frmJeu.frmChoix.cmd$i configure -image $imageFace
    } else {
      .frmJeu.frmChoix.cmd$i configure -text "$face"
    } 
    grid .frmJeu.frmChoix.cmd$i -column $colonne -row $ligne -padx 1 -ipadx 1 -ipady 1
#ajouterBoutton frmJeu.frmChoix cmdFace "Face" {choisir Face} "right"
    incr i
incr colonne
if {$colonne > $nbFacesParLigne} {
  set colonne 1
  incr ligne
}
  }

  ajouterLabel frmJeu lblGains "" $polices(ScoresJeu) $couleurs(FondFenetreJeu) $couleurs(PoliceScoresJeu) bottom

  set labelExplMises "$montantPerd $PARAM(unite) la mise"
  if {$nbFacesMiseesMax > 1} {
    append labelExplMises " ($nbFacesMiseesMax max.)"
  }
  if {$nbFacesMiseesMax <= -1} {
    append labelExplMises " (pas de limite)"
  }
if {$montantGagneMax == ""} {
  append labelExplMises " ; gagne $montantGagne $PARAM(unite)"
} else {
  append labelExplMises " ; gagne jusqu' $montantGagneMax $PARAM(unite)"
}
  ajouterLabel frmJeu lblMises "$labelExplMises" $polices(ScoresJeu) $couleurs(FondFenetreJeu) $couleurs(PoliceScoresJeu) bottom

  pack .frmJeu -expand 1 -fill both

  afficherFrame frmJeu
}

set bloque false
proc commencerJeu {} {
  global couleurs
  global faceTiree
  global bloque

#  set faceMisee ""
  set faceTiree ""
  set bloque false

  majNomsEtScores .frmJeu.lblGains
  majAfficheJeu
}

proc tirerFace {} {
  global faceTiree
  set faceTiree [tirerOutilAvecRemise]
}

proc tirer {} {
  global faceTiree
  global facesMisees
  global montantGagne
  global montantPerd
  global titreJeu
  global challenge
  global delaiAvantEfface
  global bloque

  if {! $bloque} {
    set bloque true
    set nbMises [llength $facesMisees]
    if {$nbMises > 0} {
incrementerStats "nb mises" false $nbMises
      set investi [expr {$nbMises * $montantPerd}]
      perdre $investi 1
      majNomsEtScores .frmJeu.lblGains
incrementerStats "montant investi" false $investi
      animer
      tirerFace
      set faceTireeTmp $faceTiree ;# On sauvegarde parceque parfois, elle pourra tre efface dans majAfficheJeu (ex : paris_course)...
      majAfficheJeu false
      set faceTiree $faceTireeTmp
      if {[lsearch $facesMisees $faceTiree] >= 0} {
        # gagn
        gagner $montantGagne 1
        majNomsEtScores .frmJeu.lblGains
incrementerStats "total gains" false $montantGagne
      }
if {$faceTiree != ""} {
  incrementerStats $faceTiree
}
        pause $delaiAvantEfface
      if {$challenge} {
        Challenge_JeuSuivant
      } else {
        commencerJeu
      }
    } else {
      msgBox "Veuillez d'abord miser..." [replaceAll "$titreJeu" "\n" " "]
      set bloque false
    }
  }
}

proc animer {} {
}

proc animerALaSuite {delai nbIter} {
  global faceTiree
  global listeOutilsHasard

  set listeFaces $listeOutilsHasard(1,faces)
  set nbFaces [llength $listeFaces]
  set indFace 0
  for {set i 0} {$i < $nbIter} {incr i} {
    set faceTiree [lindex $listeFaces $indFace]
    majAfficheJeu false
    incr indFace
    if {$indFace >= $nbFaces} {
      set indFace 0
    }
    pause $delai
  }
}

proc animerAuHasard {delai nbIter} {
  global faceTiree
  for {set i 0} {$i < $nbIter} {incr i} {
    set faceTiree [tirerOutilAvecRemise]
    majAfficheJeu false
    pause $delai
  }
}


proc majAfficheJeu {{majMises true}} {
  global facesMisees
  global faceTiree
  global imagesFaces
  global couleurs
  global listeOutilsHasard

  if {$majMises} {
    set i 0
    foreach face $listeOutilsHasard(1,faces) {
      .frmJeu.frmChoix.cmd$i configure -background $couleurs(FondNonSelectionne)
      incr i
    }

    foreach face $facesMisees {
      set indFaceMisee [lsearch $listeOutilsHasard(1,faces) "$face"]
      if {$indFaceMisee >= 0} {
        .frmJeu.frmChoix.cmd$indFaceMisee configure -background $couleurs(FondSelectionne)
      }
    }
  }
  
  # On interroge les textes avant l'image
  # Pour plus de modularit dans les jeux hritant
  # (ex : ne pas afficher l'image du gagnant)
  set txtAvant [lblAvantRes]
  set txtApres [lblApresRes]
  set imageFace ""
  catch {set imageFace $imagesFaces($faceTiree)}
  if {$imageFace != ""} {
    .frmJeu.lblTirage configure -image $imageFace -text "$txtAvant$txtApres"
  } else {
    .frmJeu.lblTirage configure -text "$txtAvant$faceTiree$txtApres"
  }
  update
}

proc choisir {indFace} {
  global facesMisees
  global nbFacesMiseesMax
  global couleurs
  global listeOutilsHasard
  global nomActionTirage
  global bloque

  if {! $bloque} {
  set faceChoisie [lindex $listeOutilsHasard(1,faces) $indFace]
  set indDansMisees [lsearch $facesMisees $faceChoisie]
  if {$indDansMisees >= 0} {
    # existe dj =>  supprimer 
    set facesMisees [lreplace $facesMisees $indDansMisees $indDansMisees]
  } else {
    # on doit l'ajouter => on vrifie la taille :
    if {[llength $facesMisees] >= $nbFacesMiseesMax && $nbFacesMiseesMax > 0} {
      # on supprime le premier :
      set facesMisees [lreplace $facesMisees 0 0]
    }
    # on ajoute le nouveau !
    lappend facesMisees $faceChoisie
  }
  majAfficheJeu
  if {$nomActionTirage == "" && $nbFacesMiseesMax == 1} {
    tirer
  }
  }
}
