global REP_JEUX
global PARAM
source [file join $REP_JEUX "Jeux_Pari_1_1.tcl"]

global outils
set outils(0,nbFacesATirer) 0
set outils(0,0,valeur) ""

global listeSommesPossibles
set listeSommesPossibles [list]

proc valeurFace {face} {
  msgBox "valeurFace(face) :  crire !"
  return 0
}



proc lblEsperanceMathematique {} {
  msgBox "Non encore implmente dans Jeux_Pari_Somme" "Esprance mathmatique"
}

proc lblAideJeu {} {
  msgBox "But du jeu : Parier sur une ou plusieurs sommes en esprant remporter le gain." "Aide"
}

proc initAfficheJeu {} {
  global couleurs
  global polices
  global listeOutilsHasard
global nbOutilsHasard
global listeSommesPossibles
global outils
  global titreJeu
  global nomActionTirage
  global nbFacesMiseesMax
  global montantGagne
  global montantPerd
  global imagesFaces
  global PARAM
  global montantGagneMax

  destroy .frmJeu
  frame .frmJeu -background $couleurs(FondFenetreJeu)
  ajouterLigneVideHaut frmJeu $couleurs(FondFenetreJeu)
  ajouterLigneVideBas frmJeu $couleurs(FondFenetreJeu)

  ajouterLabel frmJeu lblTitre "$titreJeu" $polices(TitreJeu) $couleurs(FondFenetreJeu) $couleurs(PoliceTitreJeu) "top"
  ajouterFrame frmJeu frmVideApresTitre $couleurs(FondFenetreJeu)

  ajouterFrame frmJeu frmTirage $couleurs(FondFenetreJeu)
set colonne 0
   for {set indOutil 1} {$indOutil <= $nbOutilsHasard} {incr indOutil} {
#      incr nbFacesTot [llength $listeOutilsHasard($indOutil,faces)]
#      incr nbFacesAMiserTot $outils($indOutil,nbFacesAMiserMax)
      for {set indFace 1} {$indFace <= $outils($indOutil,nbFacesATirer)} {incr indFace} {
        incr colonne
        set outils($indOutil,$indFace,valeur) ""
        label .frmJeu.frmTirage.outil$indOutil,$indFace -background $couleurs(FondFenetreJeu)
#        .frmJeu.frmTirage.outil$indOutil,$indFace configure -width 2
        majAfficheJeu $indOutil $indFace
        grid .frmJeu.frmTirage.outil$indOutil,$indFace -column $colonne -row 1 -padx 5 ;#-sticky w
      }
    }
  ajouterBoutton frmJeu cmdTirer "$nomActionTirage" {tirer} ""
#  ajouterBoutton frmJeu cmdNew "Recommencer" {commencerJeu} ""

  ajouterFrame frmJeu frmChoix $couleurs(FondFenetreJeu)

  set i 0
  foreach face $listeSommesPossibles {
    button .frmJeu.frmChoix.cmd$i -command "choisir $i" -text "$face"
    grid .frmJeu.frmChoix.cmd$i -column [expr {$i + 1}] -row 1 -padx 1
#ajouterBoutton frmJeu.frmChoix cmdFace "Face" {choisir Face} "right"
    incr i
  }

  ajouterLabel frmJeu lblGains "" $polices(ScoresJeu) $couleurs(FondFenetreJeu) $couleurs(PoliceScoresJeu) bottom

  set labelExplMises "$montantPerd $PARAM(unite) la mise"
  if {$nbFacesMiseesMax > 1} {
    append labelExplMises " ($nbFacesMiseesMax max.)"
  }
  if {$nbFacesMiseesMax <= -1} {
    append labelExplMises " (pas de limite)"
  }
  if {$montantGagneMax == ""} {
    append labelExplMises " ; gagne $montantGagne $PARAM(unite)"
  } else {
    append labelExplMises " ; gagne jusqu' $montantGagneMax $PARAM(unite)"
  }

  ajouterLabel frmJeu lblMises "$labelExplMises" $polices(ScoresJeu) $couleurs(FondFenetreJeu) $couleurs(PoliceScoresJeu) bottom

  pack .frmJeu -expand 1 -fill both

  afficherFrame frmJeu
}

proc commencerJeu {} {
  global couleurs
  global faceTiree
global outils
global nbOutilsHasard
  global bloque
  
  set bloque false

  for {set indOutil 1} {$indOutil <= $nbOutilsHasard} {incr indOutil} {
      for {set indFace 1} {$indFace <= $outils($indOutil,nbFacesATirer)} {incr indFace} {
        set outils($indOutil,$indFace,valeur) ""
        majAfficheJeu $indOutil $indFace
      }
  }

  majNomsEtScores .frmJeu.lblGains
  majAfficheJeu -1 -1 true
}

proc tirer {} {
  global outils
  global nbOutilsHasard
  global facesMisees
  global montantGagne
  global montantPerd
  global titreJeu
  global challenge
  global bloque

  if {!$bloque} {
    set bloque true
    set nbMises [llength $facesMisees]
    if {$nbMises > 0} {
      incrementerStats "nb mises" false
      set investi [expr {$nbMises * $montantPerd}]
      perdre $investi 1
      majNomsEtScores .frmJeu.lblGains
      incrementerStats "montant investi" false $investi
      animer
  
      set somme 0
      for {set indOutil 1} {$indOutil <= $nbOutilsHasard} {incr indOutil} {
        for {set indFace 1} {$indFace <= $outils($indOutil,nbFacesATirer)} {incr indFace} {
          set outils($indOutil,$indFace,valeur) [tirerOutilAvecRemise $indOutil]
          incr somme [valeurFace $outils($indOutil,$indFace,valeur)]
          majAfficheJeu $indOutil $indFace
        }
      }
      incrementerStats $somme

#    majAfficheJeu false
      if {[lsearch $facesMisees $somme] >= 0} {
        # gagn
        gagner $montantGagne 1
        majNomsEtScores .frmJeu.lblGains
        incrementerStats "total gains" false $montantGagne
      }
      if {$challenge} {
        Challenge_JeuSuivant
      } else {
        pause 2000
        commencerJeu
      }
    } else {
      msgBox "Veuillez d'abord miser..." [replaceAll "$titreJeu" "\n" " "]
    }
    set bloque false
  }
}

proc animer {} {
}

proc animerALaSuite {delai nbIter} {
  global nbOutilsHasard
  global outils
  global listeOutilsHasard

    for {set indOutil 1} {$indOutil <= $nbOutilsHasard} {incr indOutil} {
        set outils($indOutil,iter) 0
        set outils($indOutil,nbFaces) [llength $$listeOutilsHasard($indOutil,faces)]
    }

  for {set i 0} {$i < $nbIter} {incr i} {
    for {set indOutil 1} {$indOutil <= $nbOutilsHasard} {incr indOutil} {
      for {set indFace 1} {$indFace <= $outils($indOutil,nbFacesATirer)} {incr indFace} {
        set outils($indOutil,$indFace,valeur) [lindex $listeOutilsHasard($indOutil,faces) $outils($indOutil,iter)]
        majAfficheJeu $indOutil $indFace
        set outils($indOutil,iter) [expr {$outils($indOutil,iter) + 1}]
        if {$outils($indOutil,iter) >= $outils($indOutil,nbFaces)} {
          set outils($indOutil,iter) 0
        }
      }
    }
    pause $delai
  }
}

proc animerAuHasard {delai nbIter} {
  global nbOutilsHasard
  global outils

  for {set i 0} {$i < $nbIter} {incr i} {
    for {set indOutil 1} {$indOutil <= $nbOutilsHasard} {incr indOutil} {
      for {set indFace 1} {$indFace <= $outils($indOutil,nbFacesATirer)} {incr indFace} {
        set outils($indOutil,$indFace,valeur) [tirerOutilAvecRemise $indOutil]
        majAfficheJeu $indOutil $indFace
      }
    }
    pause $delai
  }
}


proc majAfficheJeu {indOutil indFace {majMises false}} {
  global facesMisees
  global faceTiree
  global imagesFaces
  global couleurs
  global listeOutilsHasard
  global nbOutilsHasard
  global outils
global listeSommesPossibles

  if {$majMises} {
    set i 0
    foreach face $listeSommesPossibles {
      .frmJeu.frmChoix.cmd$i configure -background $couleurs(FondNonSelectionne)
      incr i
    }

    foreach face $facesMisees {
      set indFaceMisee [lsearch $listeSommesPossibles "$face"]
      .frmJeu.frmChoix.cmd$indFaceMisee configure -background $couleurs(FondSelectionne)
    }
  }
  if {$indOutil >= 1 && $indFace >= 1} {
  set imageFace ""
  catch {set imageFace $imagesFaces($outils($indOutil,$indFace,valeur))}
  if {$imageFace != ""} {
    .frmJeu.frmTirage.outil$indOutil,$indFace configure -image $imageFace
  } else {
    .frmJeu.frmTirage.outil$indOutil,$indFace configure -text "$faceTiree"
  }
  }

  update
}

proc choisir {indFace} {
  global facesMisees
  global nbFacesMiseesMax
  global couleurs
  global listeSommesPossibles

  set faceChoisie [lindex $listeSommesPossibles $indFace]
  set indDansMisees [lsearch $facesMisees $faceChoisie]
  if {$indDansMisees >= 0} {
    # existe dj =>  supprimer 
    set facesMisees [lreplace $facesMisees $indDansMisees $indDansMisees]
  } else {
    # on doit l'ajouter => on vrifie la taille :
    if {[llength $facesMisees] >= $nbFacesMiseesMax && $nbFacesMiseesMax > 0} {
      # on supprime le premier :
      set facesMisees [lreplace $facesMisees 0 0]
    }
    # on ajoute le nouveau !
    lappend facesMisees $faceChoisie
  }
  majAfficheJeu 0 0 true
}
