global REP_JEUX
global PARAM
source [file join $REP_JEUX "Jeux_Gagne_Somme.tcl"]

  global couleurs
  global polices

global casinoCouleursSalle
set idSalle Zautres

set couleurs(PoliceTitreJeu) $casinoCouleursSalle($idSalle,police)
set couleurs(FondFenetreJeu) $casinoCouleursSalle($idSalle,fond)
  set couleurs(PoliceScoresJeu) "#ffffff"
  set couleurs(PoliceResultatTirage) "#999999"
  set polices(ResultatTirage) [font create -family Courier -size [expr {$PARAM(taillePoliceBase) + 1}] -slant italic]

global titreJeu
set titreJeu "La Bonne Aventure"

global nomActionTirage
set nomActionTirage "Connatre mon avenir"

global lblTirageInit
set lblTirageInit "????????\n????????\n????????"

global montantPerd
set montantPerd 5

global delaiAvantEfface
set delaiAvantEfface 8000

ajouterOutil "phrasesAvenir" 

proc lblAvantRes {} {
  global faceTiree
  set faceTiree [replaceAll $faceTiree "_" "\n"]
    return ""
}

proc lblApresRes {} {
  return ""
}

proc valeurGain {gain} {
  return 0
}

proc initAfficheJeu {} {
  global couleurs
  global polices
  global titreJeu
  global nomActionTirage
  global montantPerd
  global PARAM

  destroy .frmJeu
  frame .frmJeu -background $couleurs(FondFenetreJeu)
  ajouterLigneVideHaut frmJeu $couleurs(FondFenetreJeu)
  ajouterLigneVideBas frmJeu $couleurs(FondFenetreJeu)

  ajouterLabel frmJeu lblTitre "$titreJeu" $polices(TitreJeu) $couleurs(FondFenetreJeu) $couleurs(PoliceTitreJeu) "top"
  ajouterFrame frmJeu frmVideApresTitre $couleurs(FondFenetreJeu)

  ajouterLabel frmJeu lblTirage "" $polices(ResultatTirage) $couleurs(FondFenetreJeu) $couleurs(PoliceResultatTirage) ""

  ajouterBoutton frmJeu cmdTirer "$nomActionTirage" {tirer} ""
#  ajouterBoutton frmJeu cmdNew "Recommencer" {commencerJeu} ""

  ajouterFrame frmJeu frmVideApresTirer $couleurs(FondFenetreJeu)

  ajouterLabel frmJeu lblGains "" $polices(ScoresJeu) $couleurs(FondFenetreJeu) $couleurs(PoliceScoresJeu) bottom

  ajouterLabel frmJeu lblMises "Pour $montantPerd $PARAM(unite), je vous dit votre avenir..." $polices(ScoresJeu) $couleurs(FondFenetreJeu) $couleurs(PoliceScoresJeu) bottom

  pack .frmJeu -expand 1 -fill both

  afficherFrame frmJeu
}

proc animer {} {
  set delai 200
  set carMasque(1) "????????"
  set carMasque(2) "????????"
  set carMasque(3) "????????"
  set carDecouvreApres(1) ""
  set carDecouvreApres(2) ""
  set carDecouvreApres(3) ""
  set i 0
  while {$carMasque(1) != ""} {  
    .frmJeu.lblTirage configure -text "$carMasque(1)$carDecouvreApres(1)
$carMasque(2)$carDecouvreApres(2)
$carMasque(3)$carDecouvreApres(3)"
    update
    set carMasque(3) [string range $carMasque(3) 0 [expr {[string length $carMasque(3)]-2}]]
    set carDecouvreApres(3) "$carDecouvreApres(3) "

    if {$i > 0} {
      set carMasque(2) [string range $carMasque(2) 0 [expr {[string length $carMasque(2)]-2}]]
      set carDecouvreApres(2) "$carDecouvreApres(2) "
    }
 
    if {$i > 1} {
      set carMasque(1) [string range $carMasque(1) 0 [expr {[string length $carMasque(1)]-2}]]
      set carDecouvreApres(1) "$carDecouvreApres(1) "
    }
    pause $delai
    incr i
  }
   .frmJeu.lblTirage configure -text "$carMasque(1)$carDecouvreApres(1)
$carMasque(2)$carDecouvreApres(2)
$carMasque(3)$carDecouvreApres(3)"
update
}

proc lblAideJeu {} {
  global nbFacesMiseesMax
  global montantPerd
  global montantGagne
  global PARAM

  msgBox \
"Principe : Je prdis l'avenir, pour $montantPerd $PARAM(unite), tout simplement..." "Aide"
}
