global couleurs
global polices
global PARAM

set couleurs(PoliceTitreJeu) "#ffffff"
set couleurs(PoliceScoresJeu) "#ffffff"
set couleurs(FondFenetreJeu) "#9A9A9A"
set couleurs(Trou) "#000000"
set couleurs(ZoneMobile) "#CACACA"
set couleurs(ZoneFixe) "#7A7A7A"
set polices(TitreJeu) [font create -family Courier -size [expr {$PARAM(taillePoliceBase) + 6}] -weight bold -underline true]
set polices(ScoresJeu) [font create -family Courier -size [expr {$PARAM(taillePoliceBase) - 1}]]

global titreJeu
set titreJeu "Pices"

global lblExplique
set lblExplique "Fates tomber le plus de pices !"

# taille de la zone d'affichage
global TAILLE
proc initTaille {} {
global TAILLE
global PARAM
set TAILLE 0
set refTaille $PARAM(largeur)
if {$PARAM(hauteur) < $refTaille} {
  set refTaille $PARAM(hauteur)
}
set TAILLE [expr {int($refTaille * 9/16)}] ;# les 2/3 de l'cran
#msgBox "$TAILLE"
}
initTaille

global jeuEnCours
set jeuEnCours false
 
global pieces
set pieces(indPiece) "imageDansCanvasOuVideSiTombee"
global nbPieces
set nbPieces 0

global HAUT_PIECES
set HAUT_PIECES [image height [getImageFichier [file join "Img" "piecePile.png"]]]
global LARG_PIECES
set LARG_PIECES [image width [getImageFichier [file join "Img" "piecePile.png"]]]


global VITESSE_MOBILE
set VITESSE_MOBILE [expr {int($TAILLE / 50)}]

global DELAI_ANIM
set DELAI_ANIM 70

global montantGagne
set montantGagne 1

proc lblEsperanceMathematique {} {
  msgBox "Le calcul de l'esprance mathmatique n'est pas applicable ici." "Esprance mathmatique"
}

proc lblAideJeu {} {
  global montantGagne
  global PARAM

  msgBox "But du jeu : lancez vos pices pour pousser les autres. Chaque pice qui tombe vous rapporte $montantGagne $PARAM(unite)." "Aide"
}

proc initMachine {} {
  global pieces
  global nbPieces
  global TAILLE
  global HAUT_PIECES
  global LARG_PIECES
  
#initTaille
  set densite [nbHasard 5 10]
  set nbAMettre [expr {$densite * int($TAILLE / $LARG_PIECES * $TAILLE / $LARG_PIECES)}]
  for {set nbPieces 1} {$nbPieces <= $nbAMettre} {incr nbPieces} {
    # On ajoute une pice :
    set dansPartieMobile [nbHasard 0 1]
    set x_init [nbHasard 0 [expr {$TAILLE - $LARG_PIECES}]]
    set face "Pile"
    if {[nbHasard 0 1]} {
      set face "Face"
    }
    if {$dansPartieMobile} {
      set y_init [nbHasard [expr {1 + int($TAILLE / 3)}] [expr {int(($TAILLE * 2 / 3) - ($HAUT_PIECES / 2)) - 1}]]
      set pieces($nbPieces) [.frmJeu.c create image $x_init $y_init -image [getImageFichier [file join "Img" "piece$face\.png"]] -anchor nw] ;#-anchor nw
    } else {
      set y_init [nbHasard [expr {1 + int(($TAILLE * 2 / 3) + ($HAUT_PIECES / 2))}] [expr {$TAILLE - 1 - int($HAUT_PIECES / 2)}]]
      set y_init [nbHasard [expr {1 + int($TAILLE * 2 / 3)}] [expr {$TAILLE - 1 - int($HAUT_PIECES / 2)}]]
      set pieces($nbPieces) [.frmJeu.c create image $x_init $y_init -image [getImageFichier [file join "Img" "piece$face\.png"]] -anchor nw] ;#-anchor nw
      .frmJeu.c lower $pieces($nbPieces)
      .frmJeu.c lower baseFixe
    }
  }
  incr nbPieces -1 ;# car le for s'arrte  +1
}

proc initAfficheJeu {} {
  global couleurs
  global polices
  global titreJeu
  global montantGagne
  global PARAM
  global TAILLE
  global LARG_PIECES
  global nbPieces
  global lblExplique

initTaille
  destroy .frmJeu
  frame .frmJeu -background $couleurs(FondFenetreJeu)
  ajouterLigneVideHaut frmJeu $couleurs(FondFenetreJeu)
  ajouterLigneVideBas frmJeu $couleurs(FondFenetreJeu)

  ajouterLabel frmJeu lblTitre "$titreJeu" $polices(TitreJeu) $couleurs(FondFenetreJeu) $couleurs(PoliceTitreJeu) "top"
  ajouterFrame frmJeu frmVideApresTitre $couleurs(FondFenetreJeu)

  # Zone de jeu
#  ajouterFrame frmJeu frmZoneJeu $couleurs(FondFenetreJeu)
frame .frmJeu.frmFentes -background $couleurs(FondFenetreJeu)
#.frmJeu.frmFentes configure -width $TAILLE
pack .frmJeu.frmFentes -side top -expand true -fill x -padx [expr {int(($PARAM(largeur) - $TAILLE) / 2)}];# -fill x
#pack configure .frmJeu.frmFentes ;#-fill x
set PAD_BOUTTONS [expr {int($TAILLE / 12)}]
set police [font create -size 6]
button .frmJeu.frmFentes.cmdFente1 -command "ajouterPiece 1" -font $police -background $couleurs(FondFenetreJeu) -activebackground $couleurs(FondFenetreJeu) ;# -text "     "
pack .frmJeu.frmFentes.cmdFente1 -fill both -expand true -side left -padx $PAD_BOUTTONS ;#-row 1 -column 1 -sticky nsew
button .frmJeu.frmFentes.cmdFente2 -command "ajouterPiece 2" -font $police -background $couleurs(FondFenetreJeu) -activebackground $couleurs(FondFenetreJeu) ;# -text "     "
pack .frmJeu.frmFentes.cmdFente2 -fill both -expand true -side left -padx $PAD_BOUTTONS ;#-row 1 -column 2 -sticky nsew
button .frmJeu.frmFentes.cmdFente3 -command "ajouterPiece 3" -font $police -background $couleurs(FondFenetreJeu) -activebackground $couleurs(FondFenetreJeu) ;# -text "     "
pack .frmJeu.frmFentes.cmdFente3 -fill both -expand true -side left -padx $PAD_BOUTTONS ;#-row 1 -column 3 -sticky nsew

set tailleMax $TAILLE
  set TAILLE [expr {int($TAILLE - $LARG_PIECES)}]
  canvas .frmJeu.c -background $couleurs(Trou) -height $tailleMax -width $TAILLE
  .frmJeu.c create rectangle 0 0 $TAILLE $TAILLE -fill $couleurs(ZoneFixe) -tag baseFixe ;#-anchor nw
.frmJeu.c lower baseFixe
  .frmJeu.c create rectangle 0 [expr {int(0 - $TAILLE / 3)}] $TAILLE [expr {int($TAILLE * 2 / 3)}] -fill $couleurs(ZoneMobile) -tag baseMobile ;#-anchor nw
  pack .frmJeu.c -side top

  ajouterLabel frmJeu lblGains "" $polices(ScoresJeu) $couleurs(FondFenetreJeu) $couleurs(PoliceScoresJeu) bottom

button .frmJeu.cmdChanger -command "initTaille; initAfficheJeu; initMachine; majNomsEtScores .frmJeu.lblGains" -text "Changer de machine" -font $polices(ScoresJeu) \
       -background $couleurs(FondFenetreJeu) -activebackground $couleurs(FondFenetreJeu) \
       -foreground $couleurs(Police) -activeforeground $couleurs(Police) ;# -text "     "
pack .frmJeu.cmdChanger -fill none -expand false -side bottom ;# -padx $PAD_BOUTTONS ;#-row 1 -column 1 -sticky nsew

  pack .frmJeu -expand 1 -fill both

  afficherFrame frmJeu
}

global nbCoupsSansJouer
set nbCoupsSansJouer 0

proc ajouterPiece {indFente} {
  global TAILLE
  global LARG_PIECES
  global pieces
  global nbPieces
  global TAILLE
  global HAUT_PIECES
  global LARG_PIECES
  global montantGagne
  global joueurs
  global nbCoupsSansJouer

  if {$joueurs(1,score) >= $montantGagne} {
    if {$nbCoupsSansJouer <= 0} {
      # OK !
      set nbCoupsSansJouer 1
      perdre $montantGagne
      majNomsEtScores .frmJeu.lblGains
      incrementerStats "montant investi" false $montantGagne
  
      set x_init [expr {int( ($TAILLE * $indFente / 4) - ($LARG_PIECES / 2) )}]
      set alea [nbHasard [expr {0 - int($LARG_PIECES / 2)}] [expr {int($LARG_PIECES / 2)}]]
      incr x_init $alea
      set y_init 0
      set face "Pile"
      if {[nbHasard 0 1]} {
        set face "Face"
      }
      incr nbPieces
      set pieces($nbPieces) [.frmJeu.c create image $x_init $y_init -image [getImageFichier [file join "Img" "piece$face\.png"]] -anchor nw] ;#-anchor nw
      .frmJeu.c lower $pieces($nbPieces)
      .frmJeu.c lower baseMobile
      .frmJeu.c lower baseFixe
    }
  } else {
    msgBox "Vous n'avez pas suffisamment d'argent pour jouer..." "FForaine"
  }
}


set bloque false
global nomJeuLance
set nomJeuLance ""
proc commencerJeu {} {
  global jeuEnCours
  global nomJeuCourant
  global nomJeuLance
  global bloque

  #  set nbPlombsRestants 0
  set jeuEnCours true
  set bloque false
  set nomJeuLance "$nomJeuCourant"
  
  initAfficheJeu
  initMachine
  majAfficheJeu
  majNomsEtScores .frmJeu.lblGains
#  focus -force .frmJeu.frmZone2.frmZoneVise
  update idletasks
  animer
}

proc animer {} {
  global pieces
  global nbPieces
  global jeuEnCours
  global frmCourante
  global DELAI_ANIM
  global VITESSE_MOBILE
  global TAILLE
  global HAUT_PIECES
  global nomJeuCourant
  global nomJeuLance
  global lstPiecesPoussees
  global nbCoupsSansJouer

  while {$jeuEnCours && ($nomJeuCourant == $nomJeuLance)} {
    if {$nbCoupsSansJouer > 0} {
      # Il a jou il n'y a pas longtemps
      incr nbCoupsSansJouer
      if {$nbCoupsSansJouer >= 5} {
        # On attend au-moins 5 tours avant de permettre de rejouer
        set nbCoupsSansJouer 0 ;# On peut rejouer, maintenant
      }
    }
    pause $DELAI_ANIM
    set lstPiecesPoussees [list]
    foreach {x y c d} [.frmJeu.c coords baseMobile] {break}
    if {$VITESSE_MOBILE > 0} {
      # il descend => y augmente pour se rapprocher de 0
      if {[expr {$y + $VITESSE_MOBILE}] > [expr {0 - $TAILLE / 3}]} {
        set VITESSE_MOBILE [expr {0 - $VITESSE_MOBILE}]
      } 
    } else {
      # il remonte => y diminue pour s'loigner de 0
      if {[expr {$y + $VITESSE_MOBILE}] < [expr {0 - $TAILLE * 2 / 3}]} {
        set VITESSE_MOBILE [expr {0 - $VITESSE_MOBILE}]
      } 
    }
    .frmJeu.c coords baseMobile [list $x [expr {$y + $VITESSE_MOBILE}] $c [expr {$d + $VITESSE_MOBILE}] ]
    for {set indPiece 1} {$indPiece <= $nbPieces} {incr indPiece} {
      catch {set liste [.frmJeu.c coords $pieces($indPiece)]
             foreach {x y} $liste {break}}
      if {$pieces($indPiece) != ""} {
        if {[expr {$y + ($HAUT_PIECES / 2)}] < $d} {
          # la pice est sur la partie mobile
          set nouvY [expr {$y + $VITESSE_MOBILE}]
          .frmJeu.c coords $pieces($indPiece) [list $x $nouvY]
          if {$nouvY < 0} {
            # Elle "bute" => on doit la pousser
            #set nouvY 0
            pousserPiece $indPiece [expr {0 - $VITESSE_MOBILE}] 0
          }
        } else {
          # Elle est sur la partie fixe
          if {$y < $d} {
            # Elle "bute" => on doit la pousser
            #set nouvY 0
            pousserPiece $indPiece [expr {0 + $VITESSE_MOBILE}] $d
          .frmJeu.c coords $pieces($indPiece) [list $x $d]
          }
          if {[expr {$y + ($HAUT_PIECES / 2)}] > $TAILLE} {
            # Elle tombe !
            gagnerPiece $indPiece
          }
        }
      }
    }
    update

    if {$frmCourante != "frmJeu"} {
      set continuer false
      set jeuEnCours false
      sauverStats
    }
  }
}

proc gagnerPiece {indPiece} {
  global pieces
  global montantGagne
  
#pause 500
gagner $montantGagne
majNomsEtScores .frmJeu.lblGains
incrementerStats "total gains" false $montantGagne
  .frmJeu.c delete $pieces($indPiece)
  set pieces($indPiece) ""
}

global lstPiecesPoussees
set lstPiecesPoussees [list]

proc pousserPiece {indPiece force {jusquaY -1}} {
  global pieces
  global nbPieces
  global TAILLE
  global HAUT_PIECES
  global LARG_PIECES
  global lstPiecesPoussees

  if {$pieces($indPiece) != "" && $force != 0} {
    set liste [.frmJeu.c coords $pieces($indPiece)]
    foreach {x y} $liste {break}

    if {[llength $lstPiecesPoussees] == 0} {
      # On parcourt les pices pour voir lesquelles pousser (en fait, celles qui sont aux mmes coordX ( la largeur prs) :
      for {set i 1} {$i <= $nbPieces} {incr i} {
        set liste [.frmJeu.c coords $pieces($i)]
        foreach {x2 y2} $liste {break}
        if {$pieces($i) != "" && $x2 > $x - $LARG_PIECES && $x2 < $x + $LARG_PIECES} {
          lappend lstPiecesPoussees $i
        }
      }
    }
    
    # On dcale dj la premire concerne :
    if {($y < $jusquaY && $force > 0) || ($y > $jusquaY && $force < 0)  || $jusquaY < 0} {
      set y [expr {$y + $force}]
      if {$jusquaY >= 0} {
        if {$force > 0} {
          if {$y > $jusquaY} {
            set force [expr {$jusquaY - $y}]
            set y $jusquaY
          }
        } else {
          if {$y < $jusquaY} {
            set force [expr {$jusquaY - $y}]
            set y $jusquaY
          }
        }
      }
      # On pousse dj la premire :
      .frmJeu.c coords $pieces($indPiece) [list $x $y]

      if {$force != 0} {
        # On parcourt maintenant toutes les pices  pousser :
        foreach i $lstPiecesPoussees {
          set liste [.frmJeu.c coords $pieces($i)]
          foreach {x2 y2} $liste {break}
          if {$force != 0} {
            #On regarde la distance qui les spare en Y :
            set dist [expr {int($y - $y2)}]
            if {$dist < 0} {
              set dist [expr {0 - $dist}]
            }
            if {($dist <= $HAUT_PIECES) && (($force > 0 && $y2 > $y) || ($force < 0 && $y2 < $y)) && [nbHasard 0 1]} {
              set decr [nbHasard 1 $force]
              if {$force < 0} {
                set decr [expr {0 - $decr}]
                if {$decr < $force} {
                  set decr $force
                }
              } else {
                if {$decr > $force} {
                  set decr $force
                }
              }
              set force [expr {$force - $decr}]
              pousserPiece $i $force
            }
          }
        }
      }
    }
  }
}

proc estPieceMobile {indPiece} {
  global pieces
  global TAILLE
  
  set mobile false
  if {$pieces($indPiece) != ""} {
    foreach {x y c d} [.frmJeu.c coords baseMobile] {break}
    set liste [.frmJeu.c coords $pieces($indPiece)]
    foreach {x y} $liste {break}
    if {$y < $d} {
      set mobile true
    }
  }
  return $mobile
}



proc majAfficheJeu {} {
#  global nbPlombsRestants

#  .frmJeu.lblNbRestants configure -text "Nb plombs restants : $nbPlombsRestants"
}
