global REP_JEUX
global PARAM
source [file join $REP_JEUX "Jeux_Grille.tcl"]

global couleurs
global polices

set couleurs(PoliceTitreJeu) "#ffff00"
set couleurs(PoliceScoresJeu) "#ffffff"
set couleurs(FondFenetreJeu) "#007700"
set couleurs(FondOutilSelectionne) "#ffff00"
set couleurs(FondOutilNonSelectionne) $couleurs(FondFenetreJeu) ;#"#FFFFFF"
#set polices(TitreJeu) [font create -family Courier -size [expr $PARAM(taillePoliceBase) + 4] -weight bold -underline true]
#set polices(ScoresJeu) [font create -family Courier -size $PARAM(taillePoliceBase) -slant italic]


global nbOutils
set nbOutils 5

for {set i 1} {$i <= $nbOutils} {incr i} {
  ajouterOutil "de"
}

global nbCoupsMax
set nbCoupsMax 3
global carMarqueCoup
set carMarqueCoup "O"

global nbTours
set nbTours -1 ;# on suppose qu'il faut remplir toute la grille

global imagesFaces
global listeOutilsHasard
foreach face $listeOutilsHasard(1,faces) {
  set imagesFaces($face) [getImageFichier [file join "Img" "DeRouge_$face.png"]]
}

global titreJeu
set titreJeu "Yam's"

global nomActionTirage
set nomActionTirage "Lancer les ds"

global montantPerd
set montantPerd 0

global bonusSiResteCoups
set bonusSiResteCoups 0

global PARAM
global labelExplMises
set labelExplMises "\nFinir la grille\n\n$nbCoupsMax lancers par tour"
if {$bonusSiResteCoups != 0} {
  append labelExplMises "\n\n$bonusSiResteCoups $PARAM(unite) par\nlancer restant !"
}

global cocheGrilleAuto
set cocheGrilleAuto false

global grille
creerGrilleFichier [file join $REP_JEUX "Jeu_Yams_Grille.txt"]

proc gainSpecial {gainInitial} {
  global bonusSiResteCoups
  global nbCoupsMax
  global nbCoups

  if {$bonusSiResteCoups != 0 && $gainInitial != 0} {
    set nbReste [expr {$nbCoupsMax - $nbCoups}]
    return [expr {($bonusSiResteCoups * $nbReste) + $gainInitial}]
  } else {
    return $gainInitial
  }
}

proc majTotaux {{dernierGain 0}} {
  global grille
  # Mise  jour du total1
  set caseTot1 8

  set tot1 0
  set continuer true
  set fini true
  set i 1
  while {$continuer} {
    set val $grille($i,score)
    if {$val != ""} {
      set tot1 [expr {$tot1 + $val}]
    } else {
      set fini false
#      set continuer false
#      set tot1 -1
    }
      incr i
      if {$i > 6} {
        set continuer false
      } 
  }
  .frmJeu.frmGrille.cmdGrille$caseTot1 configure -text "$tot1"
  if {$tot1 >= 63 || $fini} {
    # termin !
    set caseBonus [expr {$caseTot1 + 1}]
    set grille($caseBonus,score) 0
    if {$tot1 >= 63} {
      set grille($caseBonus,score) 27
    }
    gagner $grille($caseBonus,score) 1
    majNomsEtScores .frmJeu.frmTirage.lblGains
    .frmJeu.frmGrille.cmdGrille$caseBonus configure -text "$grille($caseBonus,score)"

  } ;# sinon, pas encore termin...

  gagner $dernierGain 1
  majNomsEtScores .frmJeu.frmTirage.lblGains
update
}

proc SuiteDe {nbFacesSuite} {
  set listeTriee [listeFacesOrdre]
  set ok false
  if {[contient $listeTriee "3"] && [contient $listeTriee "4"]} {
    if {$nbFacesSuite == 5} {
      if {[contient $listeTriee "2"] && [contient $listeTriee "5"]} {
        set ok [expr {([contient $listeTriee "1"] || [contient $listeTriee "6"])}]
      }
    } else {
      set ok [expr {(([contient $listeTriee "1"] && [contient $listeTriee "2"]) || \
              ([contient $listeTriee "2"] && [contient $listeTriee "5"]) || \
              ([contient $listeTriee "5"] && [contient $listeTriee "6"]))}]
    }
  } 
  return $ok
}


proc animer {} {
  set nbAnim [expr {int(rand() * 4) + 6}]
  animerAuHasard 70 $nbAnim
}

proc lblAideJeu {} {
  global nbCoupsMax
  global montantPerd
  global PARAM

  msgBox \
"But du jeu : Remplir la grille et obtenir le score le plus lev possible.

Principe : Lancez les ds, choisissez ceux que vous voulez garder et re-lancez les autres.\
Aprs $nbCoupsMax lancers maximum, choisissez dans la grille la case o inscrire vos points\
selon la combinaison obtenue.\
Le jeu est termin lorsque toute la grille est remplie.

Rapports : jouez $montantPerd $PARAM(unite) ; \
remportez la totalit de vos points !" "Aide"
}
