global couleurs
global polices
global PARAM

set couleurs(PoliceTitreJeu) "#ffff00"
set couleurs(PoliceScoresJeu) "#ffffff"
set couleurs(PoliceResultatTirage) "#ffffff"
set couleurs(FondFenetreJeu) "#007700"
set polices(TitreJeu) [font create -family Courier -size [expr {$PARAM(taillePoliceBase) + 6}] -weight bold -underline true]
set polices(ScoresJeu) [font create -family Courier -size $PARAM(taillePoliceBase) -slant italic]
set polices(ResultatTirage) [font create -family Courier -size [expr {$PARAM(taillePoliceBase) + 2}] -weight bold]


global titreJeu
set titreJeu "!!! Titre !!!"

global nomActionTirage
set nomActionTirage "Lancer le d !"

global lblTirageInit
set lblTirageInit ""

global lblMisesFin
set lblMisesFin "gagne la somme indique"

global faceTiree
set faceTiree ""

global delaiAvantEfface
set delaiAvantEfface 2000

global imagesFaces
catch {unset imagesFaces}
array set imagesFaces [list]

global montantGagne
global montantPerd
set montantGagne 0
set montantPerd 1

proc lblAvantRes {} {
  return ""
}

proc lblApresRes {} {
  return ""
}


proc lblEsperanceMathematique {} {
  global listeOutilsHasard
  global montantPerd
  global titreJeu
  global PARAM

  set sommeFaces 0.0
  foreach face $listeOutilsHasard(1,faces) {
    set sommeFaces [expr {$sommeFaces + [valeurGain $face] - $montantPerd}]
  }
  set nbFaces [llength $listeOutilsHasard(1,faces)]
  set EM [expr {0.0 + $sommeFaces / $nbFaces}]
  set titre [replaceAll "$titreJeu" "\n" " "]
  set labelEM "Dans \"$titre\",\nEM = $sommeFaces / $nbFaces = $EM $PARAM(unite)"
  msgBox $labelEM "Esprance mathmatique"
}

proc lblAideJeu {} {
  msgBox "Principe : Dcouvrir et gagner la somme indique." "Aide"
}

proc initAfficheJeu {} {
  global couleurs
  global polices
  global titreJeu
  global nomActionTirage
  global montantPerd
  global PARAM
  global lblMisesFin

  destroy .frmJeu
  frame .frmJeu -background $couleurs(FondFenetreJeu)
  ajouterLigneVideHaut frmJeu $couleurs(FondFenetreJeu)
  ajouterLigneVideBas frmJeu $couleurs(FondFenetreJeu)

  ajouterLabel frmJeu lblTitre "$titreJeu" $polices(TitreJeu) $couleurs(FondFenetreJeu) $couleurs(PoliceTitreJeu) "top"
  ajouterFrame frmJeu frmVideApresTitre $couleurs(FondFenetreJeu)

  ajouterLabel frmJeu lblTirage "" $polices(ResultatTirage) $couleurs(FondFenetreJeu) $couleurs(PoliceResultatTirage) ""

  ajouterBoutton frmJeu cmdTirer "$nomActionTirage" {tirer} ""
#  ajouterBoutton frmJeu cmdNew "Recommencer" {commencerJeu} ""

  ajouterFrame frmJeu frmVideApresTirer $couleurs(FondFenetreJeu)

  ajouterLabel frmJeu lblGains "" $polices(ScoresJeu) $couleurs(FondFenetreJeu) $couleurs(PoliceScoresJeu) bottom

  ajouterLabel frmJeu lblMises "$montantPerd $PARAM(unite) la mise ; $lblMisesFin" $polices(ScoresJeu) $couleurs(FondFenetreJeu) $couleurs(PoliceScoresJeu) bottom

  pack .frmJeu -expand 1 -fill both

  afficherFrame frmJeu
}

proc commencerJeu {} {
  global couleurs
  global faceTiree
  global bloque
  
  set bloque false
  set faceTiree ""

  majNomsEtScores .frmJeu.lblGains
  majAfficheJeu
}

proc tirer {} {
  global faceTiree
  global montantGagne
  global montantPerd
  global titreJeu
  global challenge
  global delaiAvantEfface
  global bloque
  
  if {!$bloque} {
    set bloque true
incrementerStats "nb parties" false
  perdre $montantPerd 1
  majNomsEtScores .frmJeu.lblGains
  animer
  set faceTiree [tirerOutilAvecRemise]
  majAfficheJeu 
incrementerStats $faceTiree false
  set gagne [valeurGain $faceTiree]
  gagner $gagne 1
  majNomsEtScores .frmJeu.lblGains
# les stats sont sauves ici :
incrementerStats "total gains" true $gagne
  if {$challenge} {
    Challenge_JeuSuivant
  } else {
    pause $delaiAvantEfface
    commencerJeu
  }
  }
}

proc animer {} {
}

proc majAfficheJeu {} {
  global faceTiree
  global imagesFaces
  global lblTirageInit

  set imageFace ""
  catch {set imageFace $imagesFaces($faceTiree)}
  if {$imageFace != ""} {
    .frmJeu.lblTirage configure -image $imageFace -text "[lblAvantRes][lblApresRes]"
  } else {
    set lblTirage "$lblTirageInit"
    if {$faceTiree != ""} {
      set lblTirage "[lblAvantRes]$faceTiree[lblApresRes]"
    }
    .frmJeu.lblTirage configure -text "$lblTirage"
  }
}
