catch {package require wce}
catch {package require evodio}

# Procedure to play wave (RIFF) in background
namespace eval ::evodio {}

proc ::evodio::playwav {f {usercb ""}} {
  set ns [namespace current]

  package require Thread
  set slaveid [::thread::create]

  thread::send $slaveid {
    namespace eval ::evodio {}

    proc ::evodio::playsub {f {callback ""}} {
      package require evodio
      package require Thread
      
      evodio play -file $f
      if {[string compare "" $callback]} {
	set rc [catch {uplevel \#0 $callback} res]
      }
      
      ::thread::unwind
      return
    }
  }

  set cb [list ::thread::send -async [::thread::id] [list ${ns}::playdone $slaveid $usercb]]
  thread::send -async $slaveid [list ${ns}::playsub $f $cb]

  return
}

proc ::evodio::playdone {slaveid cb} {
global nbSonsEnCours
incr nbSonsEnCours -1
  set rc [catch {uplevel \#0 $cb} res]
  return
}

global nbSonsEnCours
set nbSonsEnCours 0

global sonActif
set sonActif true

set ::wcount 0 
proc jouer_son {fichier} {
  global nbSonsEnCours
  global sonActif

  if {$sonActif} {
    incr nbSonsEnCours
    ::evodio::playwav $fichier [list incr ::wcount]
  }
}
